unit Cfdi40Delphi;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// CFDI 4.0 Basico
procedure TForm1.Button1Click(Sender: TObject);
var
  i: Integer;
  hXml: LongInt;
  hBar: Thandle;

  VirtualXML_New                        : function  ( szVersion:PChar ): LongInt; cdecl;
  VirtualXML_SetVirtualPACInfo          : procedure ( p:LongInt; szUser:PChar; servidor:PChar ); cdecl;
  VirtualXML_SetComprobanteInfo_cfdi40  : procedure ( p:LongInt; Serie:PChar; Folio:PChar; Fecha:PChar; FormaDePago:PChar; CondicionesDePago:PChar; SubTotal:PChar; Descuento:PChar; Moneda:PChar; TipoCambio:PChar; Total:PChar; TipoDeComprobante:PChar; MetodoDePago:PChar; LugarExpedicion:PChar; Confirmacion:PChar; Exportacion:PChar ); cdecl;
  VirtualXML_AddCfdiRelacionado_cfdi40  : procedure ( p:LongInt; UUID:PChar ); cdecl;
  VirtualXML_AddCfdiRelacionados_cfdi40 : procedure ( p:LongInt; TipoRelacion:PChar; UUID1:PChar; UUID2:PChar; UUID3:PChar; UUID4:PChar; UUID5:PChar; UUID6:PChar; UUID7:PChar; UUID8:PChar; UUID9:PChar; UUID10:PChar); cdecl;
  VirtualXML_SetReceptorInfo_cfdi40     : procedure ( p:LongInt; RFC:PChar; Nombre:PChar; ResidenciaFiscal:PChar; NumRegIdTrib:PChar; UsoCFDI:PChar; DomicilioFiscalReceptor:PChar; RegimenFiscalReceptor:PChar ); cdecl;
  VirtualXML_SetEmisorInfo_cfdi40       : procedure ( p:LongInt; RFC:PChar; Nombre:PChar; RegimenFiscal:PChar; FacAtrAdquirente:PChar ); cdecl;
  VirtualXML_AddConcepto_cfdi40         : procedure ( p:LongInt; ClaveProdServ:PChar; NoIdentificacion:PChar; Cantidad:PChar; ClaveUnidad:PChar; Unidad:PChar; Descripcion:PChar; ValorUnitario:PChar; Importe:PChar; Descuento:PChar; ObjetoImp:PChar ); cdecl;
  VirtualXML_AddConceptoTraslado_cfdi40 : procedure ( p:LongInt; Base:PChar; Impuesto:PChar; Tipofactor:PChar; TasaOCuota:PChar; Importe:PChar ); cdecl;
  VirtualXML_SetImpuestosInfo_cfdi40    : procedure ( p:LongInt; totalImpuestosTrasladados:PChar; totalImpuestosRetenidos:PChar ); cdecl;
  VirtualXML_AddTraslado_cfdi40         : procedure ( p:LongInt; Impuesto:PChar; TipoFactor:PChar; TasaOCuota:PChar; Importe:PChar; Base:PChar ); cdecl;
  VirtualXML_GetValue                   : function  ( p:LongInt; value:LongInt ): PChar; cdecl;
  VirtualXML_ProcesaDocumentoSSL        : function  ( p:LongInt; csd:PChar; key:PChar; keypwd:PChar; outfile:PChar ): LongInt; cdecl;
  VirtualXML_Free                       : procedure ( p:LongInt ); cdecl;


begin

  hBar := LoadLibrary( 'VirtualXML.dll' );

  VirtualXML_New                        := GetProcAddress ( Hbar, 'VirtualXML_New' );
  VirtualXML_SetVirtualPACInfo          := GetProcAddress ( Hbar, 'VirtualXML_SetVirtualPACInfo' );
  VirtualXML_ProcesaDocumentoSSL        := GetProcAddress ( Hbar, 'VirtualXML_ProcesaDocumentoSSL' );
  VirtualXML_GetValue                   := GetProcAddress ( Hbar, 'VirtualXML_GetValue' );
  VirtualXML_Free                       := GetProcAddress ( Hbar, 'VirtualXML_Free' );
  VirtualXML_SetComprobanteInfo_cfdi40  := GetProcAddress ( Hbar, 'VirtualXML_SetComprobanteInfo_cfdi40' );
  VirtualXML_AddCfdiRelacionado_cfdi40  := GetProcAddress ( Hbar, 'VirtualXML_AddCfdiRelacionado_cfdi40' );
  VirtualXML_AddCfdiRelacionados_cfdi40 := GetProcAddress ( Hbar, 'VirtualXML_AddCfdiRelacionados_cfdi40' );
  VirtualXML_SetReceptorInfo_cfdi40     := GetProcAddress ( Hbar, 'VirtualXML_SetReceptorInfo_cfdi40' );
  VirtualXML_SetEmisorInfo_cfdi40       := GetProcAddress ( Hbar, 'VirtualXML_SetEmisorInfo_cfdi40' );
  VirtualXML_AddConcepto_cfdi40         := GetProcAddress ( Hbar, 'VirtualXML_AddConcepto_cfdi40' );
  VirtualXML_AddConceptoTraslado_cfdi40 := GetProcAddress ( Hbar, 'VirtualXML_AddConceptoTraslado_cfdi40' );
  VirtualXML_SetImpuestosInfo_cfdi40    := GetProcAddress ( Hbar, 'VirtualXML_SetImpuestosInfo_cfdi40' );
  VirtualXML_AddTraslado_cfdi40         := GetProcAddress ( Hbar, 'VirtualXML_AddTraslado_cfdi40' );

   //* indicamos la nueva version 4.0 */
   hXml := VirtualXML_New('4.0');

   //* credenciales de timbrado */
   VirtualXML_SetVirtualPACInfo(hXml,'demo_cibertec','demo');

   //* ejemplos de CFDI relacionados, NO SIEMPRE LOS LLEVA, revise la guia de llenado para mas informacion de estos parametor */
   VirtualXML_AddCfdiRelacionados_cfdi40(hXml,'01','01000000-0000-0000-0000-000000000001','01000000-0000-0000-0000-000000000002','01000000-0000-0000-0000-000000000003','','','','','','','');
   VirtualXML_AddCfdiRelacionado_cfdi40(hXml,'01000000-0000-0000-0000-111111111111');
   VirtualXML_AddCfdiRelacionados_cfdi40(hXml,'02','02000000-0000-0000-0000-000000000001','','','','','','','','','');
   VirtualXML_AddCfdiRelacionado_cfdi40(hXml,'02000000-0000-0000-0000-222222222222');

   //* Datos generales del comprobante*/
   VirtualXML_SetComprobanteInfo_cfdi40(hXml,'CJZ','7303','%cb_date','99','CREDITO','6034.48','0.00','MXN','1','7000.00','I','PPD','53110','','01');
   //* datos del emisor */
   VirtualXML_SetEmisorInfo_cfdi40(hXml,'EKU9003173C9','ESCUELA KEMPER URGATE','601','');
   //* datos del receptor */
   VirtualXML_SetReceptorInfo_cfdi40(hXml,'CTE940531F58','CIBERNETICA Y TECNOLOGIA','','','G03','53050','601');

   //* agregamos conceptos */
   VirtualXML_AddConcepto_cfdi40(hXml,'43211500','EQU-0025','1.000','H87','Computadora','COMPUTADORA HP PORTATIL','6034.48','6034.48','0.00','02');
   VirtualXML_AddConceptoTraslado_cfdi40(hXml,'6034.48','002','Tasa','0.160000','965.52');  // impuestos del concepto

   //* resumen de impuestos */
   VirtualXML_SetImpuestosInfo_cfdi40(hXml,'965.52','');
   VirtualXML_AddTraslado_cfdi40(hXml,'002','Tasa','0.160000','965.52','6034.48');

   //* generamos el CFDI */
   i := VirtualXML_ProcesaDocumentoSSL(hXml,'CSD_EKU9003173C9.cer','CSD_EKU9003173C9.key','12345678a','demoIngresoCFDI40.xml');


  if VirtualXML_GetValue(hXml, 1) = 'VIRTUALXML_OK' then
  begin
      application.MessageBox(VirtualXML_GetValue( hXML, 3),'No. de certificado del emisor' );
      application.MessageBox(VirtualXML_GetValue( hXML, 4),'Sello digital del emisor');
      application.MessageBox(VirtualXML_GetValue( hXML, 5),'Cadena original del documento');
      application.MessageBox(VirtualXML_GetValue( hXML, 6),'No. de certificado del SAT');
      application.MessageBox(VirtualXML_GetValue( hXML, 7),'Sello digital del timbre');
      application.MessageBox(VirtualXML_GetValue( hXML, 8),'Cadena original del timbre');
      application.MessageBox(VirtualXML_GetValue( hXML, 9),'UUID Folio fiscal');
      application.MessageBox(VirtualXML_GetValue( hXML, 10),'Fecha de generacion del timbre');
      application.MessageBox(VirtualXML_GetValue( hXML, 11),'Fecha de inicio de vigencia del certificado');
      application.MessageBox(VirtualXML_GetValue( hXML, 12),'Fecha de terminacion de vigencia del certificado');
      application.MessageBox(VirtualXML_GetValue( hXML, 13),'ID de operacion VirtualPAC');
      application.MessageBox(VirtualXML_GetValue( hXML, 14),'Cantidad de timbres disponbiles');
      application.MessageBox(VirtualXML_GetValue( hXML, 15),'Version de la libreria');
      application.MessageBox(VirtualXML_GetValue( hXML, 16),'Fecha de emision del XML');
      application.MessageBox(VirtualXML_GetValue( hXML, 17),'Mensaje del PAC');
      application.MessageBox(VirtualXML_GetValue( hXML, 18),'PAC que certifico el documento');
      application.MessageBox(VirtualXML_GetValue( hXML, 19),'No. de revision de la libreria');
      application.MessageBox(VirtualXML_GetValue( hXML, 20),'RFC del proveedor de certificacion');
      application.MessageBox(VirtualXML_GetValue( hXML, 21),'Leyenda del PAC');
    end
    else
      application.MessageBox(VirtualXML_GetValue( hXML, 2),'Descripcion del error');

    VirtualXML_Free(hXML);

  FreeLibrary(Hbar);

end;


// CFDI de Pagos 2.0
procedure TForm1.Button2Click(Sender: TObject);
var
  i: Integer;
  hXml: LongInt;
  hBar: Thandle;

  VirtualXML_New                                      : function  ( szVersion:PChar ): LongInt; cdecl;
  VirtualXML_SetVirtualPACInfo                        : procedure ( p:LongInt; szUser:PChar; servidor:PChar ); cdecl;
  VirtualXML_SetComprobanteInfo_cfdi40                : procedure ( p:LongInt; Serie:PChar; Folio:PChar; Fecha:PChar; FormaDePago:PChar; CondicionesDePago:PChar; SubTotal:PChar; Descuento:PChar; Moneda:PChar; TipoCambio:PChar; Total:PChar; TipoDeComprobante:PChar; MetodoDePago:PChar; LugarExpedicion:PChar; Confirmacion:PChar; Exportacion:PChar ); cdecl;
  VirtualXML_SetEmisorInfo_cfdi40                     : procedure ( p:LongInt; RFC:PChar; Nombre:PChar; RegimenFiscal:PChar; FacAtrAdquirente:PChar ); cdecl;
  VirtualXML_SetReceptorInfo_cfdi40                   : procedure ( p:LongInt; RFC:PChar; Nombre:PChar; ResidenciaFiscal:PChar; NumRegIdTrib:PChar; UsoCFDI:PChar; DomicilioFiscalReceptor:PChar; RegimenFiscalReceptor:PChar ); cdecl;
  VirtualXML_AddConcepto_cfdi40                       : procedure ( p:LongInt; ClaveProdServ:PChar; NoIdentificacion:PChar; Cantidad:PChar; ClaveUnidad:PChar; Unidad:PChar; Descripcion:PChar; ValorUnitario:PChar; Importe:PChar; Descuento:PChar; ObjetoImp:PChar ); cdecl;
  VirtualXML_SetPagos20                               : procedure ( p:LongInt; TotalRetencionesIVA:PChar; TotalRetencionesISR:PChar; TotalRetencionesIEPS:PChar; TotalTrasladosBaseIVA16:PChar; TotalTrasladosImpuestoIVA16:PChar; TotalTrasladosBaseIVA8:PChar; TotalTrasladosImpuestoIVA8:PChar; TotalTrasladosBaseIVA0:PChar; TotalTrasladosImpuestoIVA0:PChar; TotalTrasladosBaseIVAExento:PChar; MontoTotalPagos:PChar );cdecl;
  VirtualXML_Pagos20AddPago                           : procedure ( p:LongInt; FechaPago:PChar; FormaDePagoP:PChar; MonedaP:PChar; TipoCambioP:PChar; Monto:PChar; NumOperacion:PChar; RfcEmisorCtaOrd:PChar; NomBancoOrdExt:PChar; CtaOrdenante:PChar; RfcEmisorCtaBen:PChar; CtaBeneficiario:PChar; TipoCadPago:PChar; CertPago:PChar; CadPago:PChar; SelloPago:PChar );cdecl;
  VirtualXML_Pagos20AddPagoDoctoRelacionado           : procedure ( p:LongInt; idDocumento:PChar; Serie:PChar; Folio:PChar; MonedadDR:PChar; EquivalenciaDR:PChar; NumParcialidad:PChar; ImpSaldoAnt:PChar; ImpPagado:PChar; ImpSaldoInsoluto:PChar; ObjetoImpDR:PChar );cdecl;
  VirtualXML_Pagos20AddPagoDoctoRelacionadoTrasladoDR : procedure ( p:LongInt; BaseDR:PChar; ImpuestoDR:PChar; TipoFactorDR:PChar; TasaOCuotaDR:PChar; ImporteDR:PChar );cdecl;
  VirtualXML_Pagos20AddPagoImpuestosPTrasladoP        : procedure ( p:LongInt; BaseP:PChar; ImpuestoP:PChar; TipoFactorP:PChar; TasaOCuotaP:PChar; ImporteP:PChar );cdecl;
  VirtualXML_GetValue                                 : function  ( p:LongInt; value:LongInt ): PChar; cdecl;
  VirtualXML_ProcesaDocumento                         : function  ( p:LongInt; csd:PChar; key:PChar; keypwd:PChar; outfile:PChar ): LongInt; cdecl;
  VirtualXML_Free                                     : procedure ( p:LongInt ); cdecl;

begin

  hBar := LoadLibrary( 'VirtualXML.dll' );

  VirtualXML_New                                      := GetProcAddress ( Hbar, 'VirtualXML_New' );
  VirtualXML_SetVirtualPACInfo                        := GetProcAddress ( Hbar, 'VirtualXML_SetVirtualPACInfo' );
  VirtualXML_SetComprobanteInfo_cfdi40                := GetProcAddress ( Hbar, 'VirtualXML_SetComprobanteInfo_cfdi40' );
  VirtualXML_SetEmisorInfo_cfdi40                     := GetProcAddress ( Hbar, 'VirtualXML_SetEmisorInfo_cfdi40' );
  VirtualXML_SetReceptorInfo_cfdi40                   := GetProcAddress ( Hbar, 'VirtualXML_SetReceptorInfo_cfdi40' );
  VirtualXML_AddConcepto_cfdi40                       := GetProcAddress ( Hbar, 'VirtualXML_AddConcepto_cfdi40' );
  VirtualXML_SetPagos20                               := GetProcAddress ( Hbar, 'VirtualXML_SetPagos20' );
  VirtualXML_Pagos20AddPago                           := GetProcAddress ( Hbar, 'VirtualXML_Pagos20AddPago' );
  VirtualXML_Pagos20AddPagoDoctoRelacionado           := GetProcAddress ( Hbar, 'VirtualXML_Pagos20AddPagoDoctoRelacionado' );
  VirtualXML_Pagos20AddPagoDoctoRelacionadoTrasladoDR := GetProcAddress ( Hbar, 'VirtualXML_Pagos20AddPagoDoctoRelacionadoTrasladoDR' );
  VirtualXML_Pagos20AddPagoImpuestosPTrasladoP        := GetProcAddress ( Hbar, 'VirtualXML_Pagos20AddPagoImpuestosPTrasladoP' );
  VirtualXML_GetValue                                 := GetProcAddress ( Hbar, 'VirtualXML_GetValue' );
  VirtualXML_ProcesaDocumento                         := GetProcAddress ( Hbar, 'VirtualXML_ProcesaDocumento' );
  VirtualXML_Free                                     := GetProcAddress ( Hbar, 'VirtualXML_Free' );

   hXml := VirtualXML_New('4.0');

   VirtualXML_SetVirtualPACInfo(hXml,'demo_cibertec','demo');
   VirtualXML_SetComprobanteInfo_cfdi40(hXml,'','12629','%cb_date','','','0','','XXX','','0','P','','72150','','01');
   VirtualXML_SetEmisorInfo_cfdi40(hXml,'EKU9003173C9','ESCUELA KEMPER URGATE','601','');
   VirtualXML_SetReceptorInfo_cfdi40(hXml,'CTE940531F58','CIBERNETICA Y TECNOLOGIA','','','CP01','53050','601');
   VirtualXML_AddConcepto_cfdi40(hXml,'84111506','','1','ACT','','Pago','0','0','','01');

   //* complemento de pagos 2.0 */
   VirtualXML_SetPagos20(hXml,'','','','18620.69','2979.31','','','','','','21600.00');

   //* agregamos un pago */
   VirtualXML_Pagos20AddPago(hXml,'2022-01-10T01:01:01','03','MXN','1','10000.00','0000842','','','','','','','','','');
   //* agregamos un documento relacionado */
   VirtualXML_Pagos20AddPagoDoctoRelacionado(hXml,'8ADC78F8-4444-4444-4444-121212121212','Serie','0001','MXN','1','1','15000.00','10000.00','5000.00','02');
   //*desgloce de impuestos del documento relacionado */
   VirtualXML_Pagos20AddPagoDoctoRelacionadoTrasladoDR(hXml,'8620.69','002','Tasa','0.160000','1379.31');
   //* resumen de impuestos de todos los documentos relacionados */
   VirtualXML_Pagos20AddPagoImpuestosPTrasladoP(hXml,'8620.69','002','Tasa','0.160000','1379.31');

   //* agregamos otro pago */
   VirtualXML_Pagos20AddPago(hXml,'2022-01-01T10:01:01','03','MXN','1','11600.00','0000843','','','','','','','','','');
   VirtualXML_Pagos20AddPagoDoctoRelacionado(hXml,'8ADC78F8-4AB4-44FC-34AD-121212121212','Serie','00002','MXN','1','1','11600.00','11600.00','0.00','02');
   VirtualXML_Pagos20AddPagoDoctoRelacionadoTrasladoDR(hXml,'10000.00','002','Tasa','0.160000','1600.00');
   VirtualXML_Pagos20AddPagoImpuestosPTrasladoP(hXml,'10000.00','002','Tasa','0.160000','1600.00');

   //* generamos el CFDI */
   i := VirtualXML_ProcesaDocumento(hXml,'CSD_EKU9003173C9.cer','CSD_EKU9003173C9.key','12345678a','demoPagos20CFDI40.xml');


  if VirtualXML_GetValue(hXml, 1) = 'VIRTUALXML_OK' then
  begin
      application.MessageBox(VirtualXML_GetValue( hXML, 3),'No. de certificado del emisor' );
      application.MessageBox(VirtualXML_GetValue( hXML, 4),'Sello digital del emisor');
      application.MessageBox(VirtualXML_GetValue( hXML, 5),'Cadena original del documento');
      application.MessageBox(VirtualXML_GetValue( hXML, 6),'No. de certificado del SAT');
      application.MessageBox(VirtualXML_GetValue( hXML, 7),'Sello digital del timbre');
      application.MessageBox(VirtualXML_GetValue( hXML, 8),'Cadena original del timbre');
      application.MessageBox(VirtualXML_GetValue( hXML, 9),'UUID Folio fiscal');
      application.MessageBox(VirtualXML_GetValue( hXML, 10),'Fecha de generacion del timbre');
      application.MessageBox(VirtualXML_GetValue( hXML, 11),'Fecha de inicio de vigencia del certificado');
      application.MessageBox(VirtualXML_GetValue( hXML, 12),'Fecha de terminacion de vigencia del certificado');
      application.MessageBox(VirtualXML_GetValue( hXML, 13),'ID de operacion VirtualPAC');
      application.MessageBox(VirtualXML_GetValue( hXML, 14),'Cantidad de timbres disponbiles');
      application.MessageBox(VirtualXML_GetValue( hXML, 15),'Version de la libreria');
      application.MessageBox(VirtualXML_GetValue( hXML, 16),'Fecha de emision del XML');
      application.MessageBox(VirtualXML_GetValue( hXML, 17),'Mensaje del PAC');
      application.MessageBox(VirtualXML_GetValue( hXML, 18),'PAC que certifico el documento');
      application.MessageBox(VirtualXML_GetValue( hXML, 19),'No. de revision de la libreria');
      application.MessageBox(VirtualXML_GetValue( hXML, 20),'RFC del proveedor de certificacion');
      application.MessageBox(VirtualXML_GetValue( hXML, 21),'Leyenda del PAC');
    end
    else
      application.MessageBox(VirtualXML_GetValue( hXML, 2),'Descripcion del error');

    VirtualXML_Free(hXML);

  FreeLibrary(Hbar);

end;

// CFDI 4.0 de Traslado con Carta Porte 2.0
procedure TForm1.Button3Click(Sender: TObject);
var
  i: Integer;
  hXml: LongInt;
  hBar: Thandle;

  VirtualXML_New                                                        : function  ( szVersion:PChar ): LongInt; cdecl;
  VirtualXML_SetVirtualPACInfo                                          : procedure ( p:LongInt; szUser:PChar; servidor:PChar ); cdecl;
  VirtualXML_SetComprobanteInfo_cfdi40                                  : procedure ( p:LongInt; Serie:PChar; Folio:PChar; Fecha:PChar; FormaDePago:PChar; CondicionesDePago:PChar; SubTotal:PChar; Descuento:PChar; Moneda:PChar; TipoCambio:PChar; Total:PChar; TipoDeComprobante:PChar; MetodoDePago:PChar; LugarExpedicion:PChar; Confirmacion:PChar; Exportacion:PChar ); cdecl;
  VirtualXML_SetEmisorInfo_cfdi40                                       : procedure ( p:LongInt; RFC:PChar; Nombre:PChar; RegimenFiscal:PChar; FacAtrAdquirente:PChar ); cdecl;
  VirtualXML_SetReceptorInfo_cfdi40                                     : procedure ( p:LongInt; RFC:PChar; Nombre:PChar; ResidenciaFiscal:PChar; NumRegIdTrib:PChar; UsoCFDI:PChar; DomicilioFiscalReceptor:PChar; RegimenFiscalReceptor:PChar ); cdecl;
  VirtualXML_AddConcepto_cfdi40                                         : procedure ( p:LongInt; ClaveProdServ:PChar; NoIdentificacion:PChar; Cantidad:PChar; ClaveUnidad:PChar; Unidad:PChar; Descripcion:PChar; ValorUnitario:PChar; Importe:PChar; Descuento:PChar; ObjetoImp:PChar ); cdecl;
  VirtualXML_AddConceptoTraslado_cfdi40                                 : procedure ( p:LongInt; Base:PChar; Impuesto:PChar; Tipofactor:PChar; TasaOCuota:PChar; Importe:PChar ); cdecl;
  VirtualXML_SetImpuestosInfo_cfdi40                                    : procedure ( p:LongInt; totalImpuestosTrasladados:PChar; totalImpuestosRetenidos:PChar ); cdecl;
  VirtualXML_AddTraslado_cfdi40                                         : procedure ( p:LongInt; Impuesto:PChar; TipoFactor:PChar; TasaOCuota:PChar; Importe:PChar; Base:PChar ); cdecl;
  VirtualXML_SetCartaPorte20                                            : procedure ( p:LongInt; TranspInternac:PChar; EntradaSalidaMerc:PChar; PaisOrigenDestino:PChar;  ViaEntradaSalida:PChar; TotalDistRec:PChar);cdecl;
  VirtualXML_CartaPorte20AddUbicacion                                   : procedure ( p:LongInt; TipoUbicacion:PChar; IDUbicacion:PChar; RFCRemitenteDestinatario:PChar; NombreRemitenteDestinatario:PChar; NumRegIdTrib:PChar; ResidenciaFiscal:PChar; NumEstacion:PChar; NombreEstacion:PChar; NavegacionTrafico:PChar; FechaHoraSalidaLlegada:PChar; TipoEstacion:PChar; DistanciaRecorrida:PChar; Calle:PChar; NumeroExterior:PChar; NumeroInterior:PChar; Colonia:PChar; Localidad:PChar; Referencia:PChar; Municipio:PChar; Estado:PChar; Pais:PChar; CodigoPostal:PChar);cdecl;
  VirtualXML_CartaPorte20SetMercancias                                  : procedure ( p:LongInt; PesoBrutoTotal:PChar; UnidadPeso:PChar; PesoNetoTotal:PChar; NumTotalMercancias:PChar; CargoPorTasacion:PChar);cdecl;
  VirtualXML_CartaPorte20AddMercancia                                   : procedure ( p:LongInt; BienesTransp:PChar; ClaveSTCC:PChar; Descripcion:PChar; Cantidad:PChar; ClaveUnidad:PChar; Unidad:PChar; Dimensiones:PChar; MaterialPeligroso:PChar; CveMaterialPeligroso:PChar; Embalaje:PChar; DescripEmbalaje:PChar; PesoEnKg:PChar; ValorMercancia:PChar; Moneda:PChar; FraccionArancelaria:PChar; UUIDComercioExt:PChar; UnidadPesoMerc:PChar; PesoBruto:PChar; PesoNeto:PChar; PesoTara:PChar; NumPiezas:PChar);cdecl;
  VirtualXML_CartaPorte20AddMercanciaCantidadTransporta                 : procedure ( p:LongInt; Cantidad:PChar; IDOrigen:PChar; IDDestino:PChar; CvesTransporte:PChar);cdecl;
  VirtualXML_CartaPorte20SetMercanciasAutotransporte                    : procedure ( p:LongInt; PermSCT:PChar; NumPermisoSCT:PChar; ConfigVehicular:PChar; PlacaVM:PChar; AnioModeloVM:PChar; AseguraRespCivil:PChar; PolizaRespCivil:PChar; AseguraMedAmbiente:PChar; PolizaMedAmbiente:PChar; AseguraCarga:PChar; PolizaCarga:PChar; PrimaSeguro:PChar; SubTipoRem1:PChar; Placa1:PChar; SubTipoRem2:PChar; Placa2:PChar); cdecl;
  VirtualXML_CartaPorte20AddFiguraTransporteTiposFigura                 : procedure ( p:LongInt; TipoFigura:PChar; RFCFigura:PChar; NumLicencia:PChar; NombreFigura:PChar; NumRegIdTribFigura:PChar; ResidenciaFiscalFigura:PChar; ParteTransporte:PChar; Calle:PChar; NumeroExterior:PChar; NumeroInterior:PChar; Colonia:PChar; Localidad:PChar; Referencia:PChar; Municipio:PChar; Estado:PChar; Pais:PChar; CodigoPostal:PChar);cdecl;
  VirtualXML_CartaPorte20AddFiguraTransporteTiposFiguraPartesTransporte : procedure ( p:LongInt; ParteTransporte:PChar); cdecl;
  VirtualXML_GetValue                                                   : function  ( p:LongInt; value:LongInt ): PChar; cdecl;
  VirtualXML_ProcesaDocumento                                           : function  ( p:LongInt; csd:PChar; key:PChar; keypwd:PChar; outfile:PChar ): LongInt; cdecl;
  VirtualXML_Free                                                       : procedure ( p:LongInt ); cdecl;
begin

   hBar := LoadLibrary( 'VirtualXML.dll' );

  VirtualXML_New                                                        := GetProcAddress ( Hbar, 'VirtualXML_New' );
  VirtualXML_SetVirtualPACInfo                                          := GetProcAddress ( Hbar, 'VirtualXML_SetVirtualPACInfo' );
  VirtualXML_SetComprobanteInfo_cfdi40                                  := GetProcAddress ( Hbar, 'VirtualXML_SetComprobanteInfo_cfdi40' );
  VirtualXML_SetEmisorInfo_cfdi40                                       := GetProcAddress ( Hbar, 'VirtualXML_SetEmisorInfo_cfdi40' );
  VirtualXML_SetReceptorInfo_cfdi40                                     := GetProcAddress ( Hbar, 'VirtualXML_SetReceptorInfo_cfdi40' );
  VirtualXML_AddConcepto_cfdi40                                         := GetProcAddress ( Hbar, 'VirtualXML_AddConcepto_cfdi40' );
  VirtualXML_AddConceptoTraslado_cfdi40                                 := GetProcAddress ( Hbar, 'VirtualXML_AddConceptoTraslado_cfdi40' );
  VirtualXML_SetImpuestosInfo_cfdi40                                    := GetProcAddress ( Hbar, 'VirtualXML_SetImpuestosInfo_cfdi40' );
  VirtualXML_AddTraslado_cfdi40                                         := GetProcAddress ( Hbar, 'VirtualXML_AddTraslado_cfdi40' );
  VirtualXML_SetCartaPorte20                                            := GetProcAddress ( Hbar, 'VirtualXML_SetCartaPorte20' );
  VirtualXML_CartaPorte20AddUbicacion                                   := GetProcAddress ( Hbar, 'VirtualXML_CartaPorte20AddUbicacion' );
  VirtualXML_CartaPorte20SetMercancias                                  := GetProcAddress ( Hbar, 'VirtualXML_CartaPorte20SetMercancias' );
  VirtualXML_CartaPorte20AddMercancia                                   := GetProcAddress ( Hbar, 'VirtualXML_CartaPorte20AddMercancia' );
  VirtualXML_CartaPorte20AddMercanciaCantidadTransporta                 := GetProcAddress ( Hbar, 'VirtualXML_CartaPorte20AddMercanciaCantidadTransporta' );
  VirtualXML_CartaPorte20SetMercanciasAutotransporte                    := GetProcAddress ( Hbar, 'VirtualXML_CartaPorte20SetMercanciasAutotransporte' );
  VirtualXML_CartaPorte20AddFiguraTransporteTiposFigura                 := GetProcAddress ( Hbar, 'VirtualXML_CartaPorte20AddFiguraTransporteTiposFigura' );
  VirtualXML_CartaPorte20AddFiguraTransporteTiposFiguraPartesTransporte := GetProcAddress ( Hbar, 'VirtualXML_CartaPorte20AddFiguraTransporteTiposFiguraPartesTransporte' );
  VirtualXML_GetValue                                                   := GetProcAddress ( Hbar, 'VirtualXML_GetValue' );
  VirtualXML_ProcesaDocumento                                           := GetProcAddress ( Hbar, 'VirtualXML_ProcesaDocumento' );
  VirtualXML_Free                                                       := GetProcAddress ( Hbar, 'VirtualXML_Free' );

   hXml := VirtualXML_New('4.0');

   VirtualXML_SetVirtualPacInfo(hXml,'demo_cibertec','cibertec');

   //* primero creamos un CFDI de Traslado o de Traslado */
   VirtualXML_SetComprobanteInfo_cfdi40(hXml,'CP','001','%cb_date','','','0','','XXX','','0','T','','02760','','01');

    //* datos del emisor */
   VirtualXML_SetEmisorInfo_cfdi40(hXml,'EKU9003173C9','ESCUELA KEMPER URGATE','601','');

   //* datos del receptor, uso del CFDI = S01 */
   VirtualXML_SetReceptorInfo_cfdi40(hXml,'EKU9003173C9','ESCUELA KEMPER URGATE','','','S01','02760','612');

   VirtualXML_AddConcepto_cfdi40(hXml, '12164502', '1158D10887', '1', 'H87', 'Pza', 'Articulo 1','0','0','','01');
   VirtualXML_AddConcepto_cfdi40(hXml, '12164502', '1158D10887', '330', 'H87', 'Pza', 'Articulo 2','0','0','','01');

  //* inicia Carta Porte 2.0 */
   VirtualXML_SetCartaPorte20(hXml,'No','','','','2');

   //* Agregamos ubicaciones de origen y destino */
   VirtualXML_CartaPorte20AddUbicacion(hXml,'Origen','OR101010','EKU9003173C9','','','','','','','2021-11-01T00:00:00','','','calle origen 1','211','','0347','23','','004','COA','MEX','25350');
   VirtualXML_CartaPorte20AddUbicacion(hXml,'Destino','DE202020','AAA010101AAA','','','','','','','2021-11-01T01:00:00','','1','calle destino 1','214','','0347','23','entre av. lazaro cardenas y calle 32','004','COA','MEX','25350');
   VirtualXML_CartaPorte20AddUbicacion(hXml,'Destino','DE202021','AAA010101AAA','','','','','','','2021-11-01T02:00:00','','1','calle destino 2','125','','0347','23','Zorro Abarrotero','004','COA','MEX','25350');

   //* Agregamos informacion de Mercancias */
   VirtualXML_CartaPorte20SetMercancias(hXml,'2.0','XBX','','2','');
   VirtualXML_CartaPorte20AddMercancia(hXml,'11121900','','Mercancia 1','1.0','XBX','','','S','1266','4H2','','1.0','','','','','','','','','');
   VirtualXML_CartaPorte20AddMercanciaCantidadTransporta(hXml,'1','OR101010','DE202020','');
   VirtualXML_CartaPorte20AddMercancia(hXml,'11121900','','Mercancia 2','1.0','XBX','','','S','1266','4H2','','1.0','','','','','','','','','');
   VirtualXML_CartaPorte20AddMercanciaCantidadTransporta(hXml,'1','OR101010','DE202021','');

   //* informacion del vehiculo que transporta las mercancias */
   VirtualXML_CartaPorte20SetMercanciasAutotransporte(hXml,'TPAF01','NumPermisoSCT','VL','PLAC892','2009','Seguros Atlas','123456789','GNP Seguros','123456789','ABA Seguros','','','CTR003','PAX1234','','');

   //* finalmente agregamos las figuras de transporte */
   VirtualXML_CartaPorte20AddFiguraTransporteTiposFigura(hXml,'01','PEMJ420113SG1','a234567890','Vazquez Armenta Macario','','','','Brisa','423','','0347','23','Atras del estadio','004','COA','MEX','25350');
   VirtualXML_CartaPorte20AddFiguraTransporteTiposFigura(hXml,'02','PEMJ420113SG1','','Fonseca Larrea Raul','','','PT01','Padre Lerchundi','523','','0347','23','','004','COA','MEX','25350');
   VirtualXML_CartaPorte20AddFiguraTransporteTiposFiguraPartesTransporte(hXml,'PT02');
   VirtualXML_CartaPorte20AddFiguraTransporteTiposFigura(hXml,'04','PEMJ420113SG1','','','','','','Otra calle de prueba','45','','0347','23','','004','COA','MEX','25350');

  //* generamos el CFDI */
   i := VirtualXML_ProcesaDocumento(hXml,'CSD_EKU9003173C9.cer','CSD_EKU9003173C9.key','12345678a','DemoCfdi40TrasladoCartaPorte20.xml');

  if VirtualXML_GetValue(hXml, 1) = 'VIRTUALXML_OK' then
  begin
      application.MessageBox(VirtualXML_GetValue( hXML, 3),'No. de certificado del emisor' );
      application.MessageBox(VirtualXML_GetValue( hXML, 4),'Sello digital del emisor');
      application.MessageBox(VirtualXML_GetValue( hXML, 5),'Cadena original del documento');
      application.MessageBox(VirtualXML_GetValue( hXML, 6),'No. de certificado del SAT');
      application.MessageBox(VirtualXML_GetValue( hXML, 7),'Sello digital del timbre');
      application.MessageBox(VirtualXML_GetValue( hXML, 8),'Cadena original del timbre');
      application.MessageBox(VirtualXML_GetValue( hXML, 9),'UUID Folio fiscal');
      application.MessageBox(VirtualXML_GetValue( hXML, 10),'Fecha de generacion del timbre');
      application.MessageBox(VirtualXML_GetValue( hXML, 11),'Fecha de inicio de vigencia del certificado');
      application.MessageBox(VirtualXML_GetValue( hXML, 12),'Fecha de terminacion de vigencia del certificado');
      application.MessageBox(VirtualXML_GetValue( hXML, 13),'ID de operacion VirtualPAC');
      application.MessageBox(VirtualXML_GetValue( hXML, 14),'Cantidad de timbres disponbiles');
      application.MessageBox(VirtualXML_GetValue( hXML, 15),'Version de la libreria');
      application.MessageBox(VirtualXML_GetValue( hXML, 16),'Fecha de emision del XML');
      application.MessageBox(VirtualXML_GetValue( hXML, 17),'Mensaje del PAC');
      application.MessageBox(VirtualXML_GetValue( hXML, 18),'PAC que certifico el documento');
      application.MessageBox(VirtualXML_GetValue( hXML, 19),'No. de revision de la libreria');
      application.MessageBox(VirtualXML_GetValue( hXML, 20),'RFC del proveedor de certificacion');
      application.MessageBox(VirtualXML_GetValue( hXML, 21),'Leyenda del PAC');
    end
    else
      application.MessageBox(VirtualXML_GetValue( hXML, 2),'Descripcion del error');

    VirtualXML_Free(hXML);

  FreeLibrary(Hbar);

end;

//CFDI 4.0 de Ingreso con Carta Porte 2.0
procedure TForm1.Button4Click(Sender: TObject);
var
  i: Integer;
  hXml: LongInt;
  hBar: Thandle;

  VirtualXML_New                                                        : function  ( szVersion:PChar ): LongInt; cdecl;
  VirtualXML_SetVirtualPACInfo                                          : procedure ( p:LongInt; szUser:PChar; servidor:PChar ); cdecl;
  VirtualXML_SetComprobanteInfo_cfdi40                                  : procedure ( p:LongInt; Serie:PChar; Folio:PChar; Fecha:PChar; FormaDePago:PChar; CondicionesDePago:PChar; SubTotal:PChar; Descuento:PChar; Moneda:PChar; TipoCambio:PChar; Total:PChar; TipoDeComprobante:PChar; MetodoDePago:PChar; LugarExpedicion:PChar; Confirmacion:PChar; Exportacion:PChar ); cdecl;
  VirtualXML_SetEmisorInfo_cfdi40                                       : procedure ( p:LongInt; RFC:PChar; Nombre:PChar; RegimenFiscal:PChar; FacAtrAdquirente:PChar ); cdecl;
  VirtualXML_SetReceptorInfo_cfdi40                                     : procedure ( p:LongInt; RFC:PChar; Nombre:PChar; ResidenciaFiscal:PChar; NumRegIdTrib:PChar; UsoCFDI:PChar; DomicilioFiscalReceptor:PChar; RegimenFiscalReceptor:PChar ); cdecl;
  VirtualXML_AddConcepto_cfdi40                                         : procedure ( p:LongInt; ClaveProdServ:PChar; NoIdentificacion:PChar; Cantidad:PChar; ClaveUnidad:PChar; Unidad:PChar; Descripcion:PChar; ValorUnitario:PChar; Importe:PChar; Descuento:PChar; ObjetoImp:PChar ); cdecl;
  VirtualXML_AddConceptoTraslado_cfdi40                                 : procedure ( p:LongInt; Base:PChar; Impuesto:PChar; Tipofactor:PChar; TasaOCuota:PChar; Importe:PChar ); cdecl;
  VirtualXML_SetImpuestosInfo_cfdi40                                    : procedure ( p:LongInt; totalImpuestosTrasladados:PChar; totalImpuestosRetenidos:PChar ); cdecl;
  VirtualXML_AddTraslado_cfdi40                                         : procedure ( p:LongInt; Impuesto:PChar; TipoFactor:PChar; TasaOCuota:PChar; Importe:PChar; Base:PChar ); cdecl;
  VirtualXML_SetCartaPorte20                                            : procedure ( p:LongInt; TranspInternac:PChar; EntradaSalidaMerc:PChar; PaisOrigenDestino:PChar;  ViaEntradaSalida:PChar; TotalDistRec:PChar);cdecl;
  VirtualXML_CartaPorte20AddUbicacion                                   : procedure ( p:LongInt; TipoUbicacion:PChar; IDUbicacion:PChar; RFCRemitenteDestinatario:PChar; NombreRemitenteDestinatario:PChar; NumRegIdTrib:PChar; ResidenciaFiscal:PChar; NumEstacion:PChar; NombreEstacion:PChar; NavegacionTrafico:PChar; FechaHoraSalidaLlegada:PChar; TipoEstacion:PChar; DistanciaRecorrida:PChar; Calle:PChar; NumeroExterior:PChar; NumeroInterior:PChar; Colonia:PChar; Localidad:PChar; Referencia:PChar; Municipio:PChar; Estado:PChar; Pais:PChar; CodigoPostal:PChar);cdecl;
  VirtualXML_CartaPorte20SetMercancias                                  : procedure ( p:LongInt; PesoBrutoTotal:PChar; UnidadPeso:PChar; PesoNetoTotal:PChar; NumTotalMercancias:PChar; CargoPorTasacion:PChar);cdecl;
  VirtualXML_CartaPorte20AddMercancia                                   : procedure ( p:LongInt; BienesTransp:PChar; ClaveSTCC:PChar; Descripcion:PChar; Cantidad:PChar; ClaveUnidad:PChar; Unidad:PChar; Dimensiones:PChar; MaterialPeligroso:PChar; CveMaterialPeligroso:PChar; Embalaje:PChar; DescripEmbalaje:PChar; PesoEnKg:PChar; ValorMercancia:PChar; Moneda:PChar; FraccionArancelaria:PChar; UUIDComercioExt:PChar; UnidadPesoMerc:PChar; PesoBruto:PChar; PesoNeto:PChar; PesoTara:PChar; NumPiezas:PChar);cdecl;
  VirtualXML_CartaPorte20AddMercanciaCantidadTransporta                 : procedure ( p:LongInt; Cantidad:PChar; IDOrigen:PChar; IDDestino:PChar; CvesTransporte:PChar);cdecl;
  VirtualXML_CartaPorte20SetMercanciasAutotransporte                    : procedure ( p:LongInt; PermSCT:PChar; NumPermisoSCT:PChar; ConfigVehicular:PChar; PlacaVM:PChar; AnioModeloVM:PChar; AseguraRespCivil:PChar; PolizaRespCivil:PChar; AseguraMedAmbiente:PChar; PolizaMedAmbiente:PChar; AseguraCarga:PChar; PolizaCarga:PChar; PrimaSeguro:PChar; SubTipoRem1:PChar; Placa1:PChar; SubTipoRem2:PChar; Placa2:PChar); cdecl;
  VirtualXML_CartaPorte20AddFiguraTransporteTiposFigura                 : procedure ( p:LongInt; TipoFigura:PChar; RFCFigura:PChar; NumLicencia:PChar; NombreFigura:PChar; NumRegIdTribFigura:PChar; ResidenciaFiscalFigura:PChar; ParteTransporte:PChar; Calle:PChar; NumeroExterior:PChar; NumeroInterior:PChar; Colonia:PChar; Localidad:PChar; Referencia:PChar; Municipio:PChar; Estado:PChar; Pais:PChar; CodigoPostal:PChar);cdecl;
  VirtualXML_CartaPorte20AddFiguraTransporteTiposFiguraPartesTransporte : procedure ( p:LongInt; ParteTransporte:PChar); cdecl;
  VirtualXML_GetValue                                                   : function  ( p:LongInt; value:LongInt ): PChar; cdecl;
  VirtualXML_ProcesaDocumento                                           : function  ( p:LongInt; csd:PChar; key:PChar; keypwd:PChar; outfile:PChar ): LongInt; cdecl;
  VirtualXML_Free                                                       : procedure ( p:LongInt ); cdecl;
  VirtualXML_AddConceptoRetencion_cfdi40                                : procedure ( p:LongInt; Base:PChar; Impuesto:PChar; Tipofactor:PChar; TasaOCuota:PChar; Importe:PChar ); cdecl;
  VirtualXML_AddRetencion_cfdi40                                        : procedure ( p:LongInt; Impuesto:PChar; Importe:PChar ); cdecl;

begin
  hBar := LoadLibrary( 'VirtualXML.dll' );

  VirtualXML_New                                                        := GetProcAddress ( Hbar, 'VirtualXML_New' );
  VirtualXML_SetVirtualPACInfo                                          := GetProcAddress ( Hbar, 'VirtualXML_SetVirtualPACInfo' );
  VirtualXML_SetComprobanteInfo_cfdi40                                  := GetProcAddress ( Hbar, 'VirtualXML_SetComprobanteInfo_cfdi40' );
  VirtualXML_SetEmisorInfo_cfdi40                                       := GetProcAddress ( Hbar, 'VirtualXML_SetEmisorInfo_cfdi40' );
  VirtualXML_SetReceptorInfo_cfdi40                                     := GetProcAddress ( Hbar, 'VirtualXML_SetReceptorInfo_cfdi40' );
  VirtualXML_AddConcepto_cfdi40                                         := GetProcAddress ( Hbar, 'VirtualXML_AddConcepto_cfdi40' );
  VirtualXML_AddConceptoTraslado_cfdi40                                 := GetProcAddress ( Hbar, 'VirtualXML_AddConceptoTraslado_cfdi40' );
  VirtualXML_SetImpuestosInfo_cfdi40                                    := GetProcAddress ( Hbar, 'VirtualXML_SetImpuestosInfo_cfdi40' );
  VirtualXML_AddTraslado_cfdi40                                         := GetProcAddress ( Hbar, 'VirtualXML_AddTraslado_cfdi40' );
  VirtualXML_SetCartaPorte20                                            := GetProcAddress ( Hbar, 'VirtualXML_SetCartaPorte20' );
  VirtualXML_CartaPorte20AddUbicacion                                   := GetProcAddress ( Hbar, 'VirtualXML_CartaPorte20AddUbicacion' );
  VirtualXML_CartaPorte20SetMercancias                                  := GetProcAddress ( Hbar, 'VirtualXML_CartaPorte20SetMercancias' );
  VirtualXML_CartaPorte20AddMercancia                                   := GetProcAddress ( Hbar, 'VirtualXML_CartaPorte20AddMercancia' );
  VirtualXML_CartaPorte20AddMercanciaCantidadTransporta                 := GetProcAddress ( Hbar, 'VirtualXML_CartaPorte20AddMercanciaCantidadTransporta' );
  VirtualXML_CartaPorte20SetMercanciasAutotransporte                    := GetProcAddress ( Hbar, 'VirtualXML_CartaPorte20SetMercanciasAutotransporte' );
  VirtualXML_CartaPorte20AddFiguraTransporteTiposFigura                 := GetProcAddress ( Hbar, 'VirtualXML_CartaPorte20AddFiguraTransporteTiposFigura' );
  VirtualXML_CartaPorte20AddFiguraTransporteTiposFiguraPartesTransporte := GetProcAddress ( Hbar, 'VirtualXML_CartaPorte20AddFiguraTransporteTiposFiguraPartesTransporte' );
  VirtualXML_GetValue                                                   := GetProcAddress ( Hbar, 'VirtualXML_GetValue' );
  VirtualXML_ProcesaDocumento                                           := GetProcAddress ( Hbar, 'VirtualXML_ProcesaDocumento' );
  VirtualXML_Free                                                       := GetProcAddress ( Hbar, 'VirtualXML_Free' );
  VirtualXML_AddConceptoRetencion_cfdi40                                := GetProcAddress ( Hbar, 'VirtualXML_AddConceptoRetencion_cfdi40' );
  VirtualXML_AddRetencion_cfdi40                                        := GetProcAddress ( Hbar, 'VirtualXML_AddRetencion_cfdi40' );


   hXml := VirtualXML_New('4.0');

   VirtualXML_SetVirtualPACInfo(hXml, 'demo_cibertec', 'cibertec');

   //* Creamos un CFDI de ingreso  */
   VirtualXML_SetComprobanteInfo_cfdi40(hXml, 'CP2','001', '%cb_date', '01', '', '25000.00', '', 'MXN', '1', '28000.00', 'I', 'PUE', '06300', '','01');

   //* datos del emisor */
   VirtualXML_SetEmisorInfo_cfdi40(hXml,'EKU9003173C9','ESCUELA KEMPER URGATE','601','');

   VirtualXML_SetReceptorInfo_cfdi40(hXml,'FOSM380609Q76','MARTIN FLORES SOLORZANO','','','G03','53050','612');


   VirtualXML_AddConcepto_cfdi40(hXml,'78101500','01','1','E48','SERVICIO','Flete de mercancias','25000.00','25000.00','','02');
   VirtualXML_AddConceptoRetencion_cfdi40(hXml,'25000.00','002','Tasa','0.040000','1000.00');
   VirtualXML_AddConceptoTraslado_cfdi40(hXml,'25000.00','002','Tasa','0.160000','4000.00');

   VirtualXML_SetImpuestosInfo_cfdi40(hXml,'4000.00','1000.00');
   VirtualXML_AddRetencion_cfdi40(hXml,'002','1000.00');
   VirtualXML_AddTraslado_cfdi40(hXml,'002','Tasa','0.160000','4000.00','25000.00');

   //* inicia Carta Porte 2.0 */
   VirtualXML_SetCartaPorte20(hXml,'No','','','','2');

   //* Agregamos ubicaciones de origen y destino */
   VirtualXML_CartaPorte20AddUbicacion(hXml,'Origen','OR101010','EKU9003173C9','','','','','','','2021-11-01T00:00:00','','','calle origen 1','211','','0347','23','','004','COA','MEX','25350');
   VirtualXML_CartaPorte20AddUbicacion(hXml,'Destino','DE202020','CTE940531F58','','','','','','','2021-11-01T01:00:00','','1','calle destino 1','214','','0347','23','entre av. lazaro cardenas y calle 32','004','COA','MEX','25350');
   VirtualXML_CartaPorte20AddUbicacion(hXml,'Destino','DE202021','FOSM380609Q76','','','','','','','2021-11-01T02:00:00','','1','calle destino 2','125','','0347','23','Zorro Abarrotero','004','COA','MEX','25350');

   //* Agregamos informacion de Mercancias */
   VirtualXML_CartaPorte20SetMercancias(hXml,'2.0','XBX','','2','');
   VirtualXML_CartaPorte20AddMercancia(hXml,'11121900','','Mercancia 1','1.0','XBX','','','S','1266','4H2','','1.0','','','','','','','','','');
   VirtualXML_CartaPorte20AddMercanciaCantidadTransporta(hXml,'1','OR101010','DE202020','');
   VirtualXML_CartaPorte20AddMercancia(hXml,'11121900','','Mercancia 2','1.0','XBX','','','S','1266','4H2','','1.0','','','','','','','','','');
   VirtualXML_CartaPorte20AddMercanciaCantidadTransporta(hXml,'1','OR101010','DE202021','');

   //* informacion del vehiculo que transporta las mercancias */
   VirtualXML_CartaPorte20SetMercanciasAutotransporte(hXml,'TPAF01','NumPermisoSCT','VL','PLAC892','2009','Seguros Atlas','123456789','GNP Seguros','123456789','ABA Seguros','','','CTR003','PAX1234','','');

   //* finalmente agregamos las figuras de transporte */
   VirtualXML_CartaPorte20AddFiguraTransporteTiposFigura(hXml,'01','PEMJ420113SG1','a234567890','Vazquez Armenta Macario','','','','Brisa','423','','0347','23','Atras del estadio','004','COA','MEX','25350');
   VirtualXML_CartaPorte20AddFiguraTransporteTiposFigura(hXml,'02','PEMJ420113SG1','','Fonseca Larrea Raul','','','PT01','Padre Lerchundi','523','','0347','23','','004','COA','MEX','25350');
   VirtualXML_CartaPorte20AddFiguraTransporteTiposFiguraPartesTransporte(hXml,'PT02');
   VirtualXML_CartaPorte20AddFiguraTransporteTiposFigura(hXml,'04','PEMJ420113SG1','','','','','','Otra calle de prueba','45','','0347','23','','004','COA','MEX','25350');

   //* generamos el CFDI */
   i := VirtualXML_ProcesaDocumento(hXml,'CSD_EKU9003173C9.cer','CSD_EKU9003173C9.key','12345678a','DemoCfdi40IngresoCartaPorte20.xml');


  if VirtualXML_GetValue(hXml, 1) = 'VIRTUALXML_OK' then
  begin
      application.MessageBox(VirtualXML_GetValue( hXML, 3),'No. de certificado del emisor' );
      application.MessageBox(VirtualXML_GetValue( hXML, 4),'Sello digital del emisor');
      application.MessageBox(VirtualXML_GetValue( hXML, 5),'Cadena original del documento');
      application.MessageBox(VirtualXML_GetValue( hXML, 6),'No. de certificado del SAT');
      application.MessageBox(VirtualXML_GetValue( hXML, 7),'Sello digital del timbre');
      application.MessageBox(VirtualXML_GetValue( hXML, 8),'Cadena original del timbre');
      application.MessageBox(VirtualXML_GetValue( hXML, 9),'UUID Folio fiscal');
      application.MessageBox(VirtualXML_GetValue( hXML, 10),'Fecha de generacion del timbre');
      application.MessageBox(VirtualXML_GetValue( hXML, 11),'Fecha de inicio de vigencia del certificado');
      application.MessageBox(VirtualXML_GetValue( hXML, 12),'Fecha de terminacion de vigencia del certificado');
      application.MessageBox(VirtualXML_GetValue( hXML, 13),'ID de operacion VirtualPAC');
      application.MessageBox(VirtualXML_GetValue( hXML, 14),'Cantidad de timbres disponbiles');
      application.MessageBox(VirtualXML_GetValue( hXML, 15),'Version de la libreria');
      application.MessageBox(VirtualXML_GetValue( hXML, 16),'Fecha de emision del XML');
      application.MessageBox(VirtualXML_GetValue( hXML, 17),'Mensaje del PAC');
      application.MessageBox(VirtualXML_GetValue( hXML, 18),'PAC que certifico el documento');
      application.MessageBox(VirtualXML_GetValue( hXML, 19),'No. de revision de la libreria');
      application.MessageBox(VirtualXML_GetValue( hXML, 20),'RFC del proveedor de certificacion');
      application.MessageBox(VirtualXML_GetValue( hXML, 21),'Leyenda del PAC');
    end
    else
      application.MessageBox(VirtualXML_GetValue( hXML, 2),'Descripcion del error');

    VirtualXML_Free(hXML);

  FreeLibrary(Hbar);

end;

//CFDI 4.0 con Nomina 1.2
procedure TForm1.Button5Click(Sender: TObject);
var
  i: Integer;
  hXml: LongInt;
  hBar: Thandle;

  VirtualXML_New                        : function  ( szVersion:PChar ): LongInt; cdecl;
  VirtualXML_SetVirtualPACInfo          : procedure ( p:LongInt; szUser:PChar; servidor:PChar ); cdecl;
  VirtualXML_SetComprobanteInfo_cfdi40  : procedure ( p:LongInt; Serie:PChar; Folio:PChar; Fecha:PChar; FormaDePago:PChar; CondicionesDePago:PChar; SubTotal:PChar; Descuento:PChar; Moneda:PChar; TipoCambio:PChar; Total:PChar; TipoDeComprobante:PChar; MetodoDePago:PChar; LugarExpedicion:PChar; Confirmacion:PChar; Exportacion:PChar ); cdecl;
  VirtualXML_SetEmisorInfo_cfdi40       : procedure ( p:LongInt; RFC:PChar; Nombre:PChar; RegimenFiscal:PChar; FacAtrAdquirente:PChar ); cdecl;
  VirtualXML_SetReceptorInfo_cfdi40     : procedure ( p:LongInt; RFC:PChar; Nombre:PChar; ResidenciaFiscal:PChar; NumRegIdTrib:PChar; UsoCFDI:PChar; DomicilioFiscalReceptor:PChar; RegimenFiscalReceptor:PChar ); cdecl;
  VirtualXML_AddConcepto_cfdi40         : procedure ( p:LongInt; ClaveProdServ:PChar; NoIdentificacion:PChar; Cantidad:PChar; ClaveUnidad:PChar; Unidad:PChar; Descripcion:PChar; ValorUnitario:PChar; Importe:PChar; Descuento:PChar; ObjetoImp:PChar ); cdecl;
  VirtualXML_GetValue                   : function  ( p:LongInt; value:LongInt ): PChar; cdecl;
  VirtualXML_ProcesaDocumento           : function  ( p:LongInt; csd:PChar; key:PChar; keypwd:PChar; outfile:PChar ): LongInt; cdecl;
  VirtualXML_Free                       : procedure ( p:LongInt ); cdecl;
  VirtualXML_SetNomina12                : procedure ( p:LongInt; TipoNomina:PChar; FechaPago:PChar; FechaInicialPago:PChar; FechaFinalPago:PChar; NumDiasPagados:PChar; TotalPercepciones:PChar; TotalDeducciones:PChar; TotalOtrosPagos:PChar ); cdecl;
  VirtualXML_Nomina12SetEmisor          : procedure ( p:LongInt; Curp:PChar; RegistroPatronal:PChar; RfcPatronOrigen:PChar; OrigenRecurso:PChar; MontoRecursoPropio :PChar ); cdecl;
  VirtualXML_Nomina12SetReceptor        : procedure ( p:LongInt; Curp:PChar; NumSeguridadSocial:PChar; FechaInicioRelLaboral:PChar; Antiguedad:PChar; TipoContrato:PChar; Sindicalizado:PChar; TipoJornada:PChar; TipoRegimen:PChar; NumEmpleado:PChar; Departamento:PChar; Puesto:PChar; RiesgoPuesto:PChar; PeriodicidadPago:PChar; Banco:PChar; CuentaBancaria:PChar; SalarioBaseCotApor:PChar;  SalarioDiarioIntegrado:PChar;  ClaveEntFed:PChar ); cdecl;
  VirtualXML_Nomina12AddSubContratacion : procedure ( p:LongInt; RfcLabora:PChar; PorcentajeTiempo:PChar ); cdecl;
  VirtualXML_Nomina12SetPercepciones    : procedure ( p:LongInt; TotalSueldos:PChar; TotalSeparacionIndemnizacion:PChar; TotalJubilacionPensionRetiro:PChar; TotalGravado:PChar; TotalExento:PChar ); cdecl;
  VirtualXML_Nomina12AddPercepcion      : procedure ( p:LongInt; TipoPercepcion:PChar; Clave:PChar; Concepto:PChar; ImporteGravado:PChar; ImporteExento:PChar; Dias:PChar; TipoHoras:PChar; HorasExtra:PChar; ImportePagado:PChar; ValorMercado:PChar; PrecioAlOtorgarse:PChar ); cdecl;
  VirtualXML_Nomina12SetDeducciones     : procedure ( p:LongInt; TotalOtrasDeducciones:PChar; TotalImpuestosRetenidos:PChar ); cdecl;
  VirtualXML_Nomina12AddDeduccion       : procedure ( p:LongInt; TipoDeduccion:PChar; Clave:PChar; Concepto:PChar; Importe:PChar ); cdecl;
  VirtualXML_Nomina12AddOtroPago        : procedure ( p:LongInt; TipoOtroPago:PChar; Clave:PChar; Concepto:PChar; Importe:PChar; SaldoAFavor:PChar; Anio:PChar; RemanenteSalFav:PChar; SubsidioCausado:PChar ); cdecl;

begin

    hBar := LoadLibrary( 'VirtualXML.dll' );

    VirtualXML_New                        := GetProcAddress ( Hbar, 'VirtualXML_New' );
    VirtualXML_SetVirtualPACInfo          := GetProcAddress ( Hbar, 'VirtualXML_SetVirtualPACInfo' );
    VirtualXML_SetComprobanteInfo_cfdi40  := GetProcAddress ( Hbar, 'VirtualXML_SetComprobanteInfo_cfdi40' );
    VirtualXML_SetEmisorInfo_cfdi40       := GetProcAddress ( Hbar, 'VirtualXML_SetEmisorInfo_cfdi40' );
    VirtualXML_SetReceptorInfo_cfdi40     := GetProcAddress ( Hbar, 'VirtualXML_SetReceptorInfo_cfdi40' );
    VirtualXML_AddConcepto_cfdi40         := GetProcAddress ( Hbar, 'VirtualXML_AddConcepto_cfdi40' );
    VirtualXML_GetValue                   := GetProcAddress ( Hbar, 'VirtualXML_GetValue' );
    VirtualXML_ProcesaDocumento           := GetProcAddress ( Hbar, 'VirtualXML_ProcesaDocumento' );
    VirtualXML_Free                       := GetProcAddress ( Hbar, 'VirtualXML_Free' );
    VirtualXML_SetNomina12                := GetProcAddress ( Hbar, 'VirtualXML_SetNomina12' );
    VirtualXML_Nomina12SetEmisor          := GetProcAddress ( Hbar, 'VirtualXML_Nomina12SetEmisor' );
    VirtualXML_Nomina12SetReceptor        := GetProcAddress ( Hbar, 'VirtualXML_Nomina12SetReceptor' );
    VirtualXML_Nomina12AddSubContratacion := GetProcAddress ( Hbar, 'VirtualXML_Nomina12AddSubContratacion' );
    VirtualXML_Nomina12SetPercepciones    := GetProcAddress ( Hbar, 'VirtualXML_Nomina12SetPercepciones' );
    VirtualXML_Nomina12AddPercepcion      := GetProcAddress ( Hbar, 'VirtualXML_Nomina12AddPercepcion' );
    VirtualXML_Nomina12SetDeducciones     := GetProcAddress ( Hbar, 'VirtualXML_Nomina12SetDeducciones' );
    VirtualXML_Nomina12AddDeduccion       := GetProcAddress ( Hbar, 'VirtualXML_Nomina12AddDeduccion' );
    VirtualXML_Nomina12AddOtroPago        := GetProcAddress ( Hbar, 'VirtualXML_Nomina12AddOtroPago' );

    hXml := VirtualXML_New('4.0');

   //* credenciales de timbrado */
   VirtualXML_SetVirtualPACInfo(hXml,'demo_cibertec','demo');

   //* Datos generales del comprobante*/
   VirtualXML_SetComprobanteInfo_cfdi40(hXml,'NOM','1234','%cb_date','','','8628.40','2315.83','MXN','','6312.57','N','PUE','07270','','01');

   //* datos del emisor */
   VirtualXML_SetEmisorInfo_cfdi40(hXml,'EKU9003173C9','ESCUELA KEMPER URGATE','601','');

   //* datos del receptor, uso del CFDI = CN01, Regimen del receptor = 605 */
   VirtualXML_SetReceptorInfo_cfdi40(hXml,'FOSM380609Q76','MARTIN FLORES SOLORZANO','','','CN01','53050','605');

   //* concepto similar al concepto de Nomina 1.2, solo agregar 01 en objeto de impuestos */
   VirtualXML_AddConcepto_cfdi40(hXml,'84111505','','1','ACT','','Pago de nmina','8628.40','8628.40','2315.83','01');

   //* complmento de nomina se elabora similiar a como se hace en la version anterior */
   VirtualXML_SetNomina12(hXml,'O','2022-01-01','2022-01-15','2022-01-15','15','8628.40','2315.83','0.00');
   VirtualXML_Nomina12SetEmisor(hXml,'','20035','','','');
   VirtualXML_Nomina12SetReceptor(hXml,'FOSM380609HDFLLR08','01186258','2022-01-01','P15D','01','','01','02','164','UNIDAD DE APOYO ADMINISTRATIVA','Director','1','04','012','2785594979','8302.95','546.00','MEX');
   VirtualXML_Nomina12SetPercepciones(hXml,'8628.40','0.00','0.00','8210.40','418.00');
   VirtualXML_Nomina12AddPercepcion(hXml,'001','001','SUELDO BASE','5560.80','0.00','','','','','','');
   VirtualXML_Nomina12AddPercepcion(hXml,'002','002','GRATIFICACION','1581.15','0.00','','','','','','');
   VirtualXML_Nomina12AddPercepcion(hXml,'038','016','COMPENSACION POR RETABULACION','1068.45','0.00','','','','','','');
   VirtualXML_Nomina12AddPercepcion(hXml,'029','029','DESPENSA','0.00','418.00','','','','','','');
   VirtualXML_Nomina12SetDeducciones(hXml,'1116.65', '1199.18');
   VirtualXML_Nomina12AddDeduccion(hXml,'001','001','CUOTAS DE SERVICIO DE SALUD','349.65');
   VirtualXML_Nomina12AddDeduccion(hXml,'001','001','CUOTAS AL SISTEMA SOLIDARIO DE REPARTO','461.16');
   VirtualXML_Nomina12AddDeduccion(hXml,'001','001','CUOTAS AL SISTEMA DE CAPITALIZACION INDIVIDUAL','105.84');
   VirtualXML_Nomina12AddDeduccion(hXml,'002','002','ISR','1199.18');
   VirtualXML_Nomina12AddDeduccion(hXml,'004','004','AHORRO VOLUNTARIO','200.00');
   VirtualXML_Nomina12AddOtroPago(hXml,'002','CredSal','Credito al Salario','0.00','','','','0.00');

    //* generamos el CFDI */
   i := VirtualXML_ProcesaDocumento(hXml,'CSD_EKU9003173C9.cer','CSD_EKU9003173C9.key','12345678a','DemoCfdi40Nomina12.xml');

  if VirtualXML_GetValue(hXml, 1) = 'VIRTUALXML_OK' then
  begin
      application.MessageBox(VirtualXML_GetValue( hXML, 3),'No. de certificado del emisor' );
      application.MessageBox(VirtualXML_GetValue( hXML, 4),'Sello digital del emisor');
      application.MessageBox(VirtualXML_GetValue( hXML, 5),'Cadena original del documento');
      application.MessageBox(VirtualXML_GetValue( hXML, 6),'No. de certificado del SAT');
      application.MessageBox(VirtualXML_GetValue( hXML, 7),'Sello digital del timbre');
      application.MessageBox(VirtualXML_GetValue( hXML, 8),'Cadena original del timbre');
      application.MessageBox(VirtualXML_GetValue( hXML, 9),'UUID Folio fiscal');
      application.MessageBox(VirtualXML_GetValue( hXML, 10),'Fecha de generacion del timbre');
      application.MessageBox(VirtualXML_GetValue( hXML, 11),'Fecha de inicio de vigencia del certificado');
      application.MessageBox(VirtualXML_GetValue( hXML, 12),'Fecha de terminacion de vigencia del certificado');
      application.MessageBox(VirtualXML_GetValue( hXML, 13),'ID de operacion VirtualPAC');
      application.MessageBox(VirtualXML_GetValue( hXML, 14),'Cantidad de timbres disponbiles');
      application.MessageBox(VirtualXML_GetValue( hXML, 15),'Version de la libreria');
      application.MessageBox(VirtualXML_GetValue( hXML, 16),'Fecha de emision del XML');
      application.MessageBox(VirtualXML_GetValue( hXML, 17),'Mensaje del PAC');
      application.MessageBox(VirtualXML_GetValue( hXML, 18),'PAC que certifico el documento');
      application.MessageBox(VirtualXML_GetValue( hXML, 19),'No. de revision de la libreria');
      application.MessageBox(VirtualXML_GetValue( hXML, 20),'RFC del proveedor de certificacion');
      application.MessageBox(VirtualXML_GetValue( hXML, 21),'Leyenda del PAC');
    end
    else
      application.MessageBox(VirtualXML_GetValue( hXML, 2),'Descripcion del error');

    VirtualXML_Free(hXML);

  FreeLibrary(Hbar);
end;

// CFDI 4.0 por ventas del dia
procedure TForm1.Button6Click(Sender: TObject);
var
  i: Integer;
  hXml: LongInt;
  hBar: Thandle;

  VirtualXML_New                         : function  ( szVersion:PChar ): LongInt; cdecl;
  VirtualXML_SetVirtualPACInfo           : procedure ( p:LongInt; szUser:PChar; servidor:PChar ); cdecl;
  VirtualXML_SetComprobanteInfo_cfdi40   : procedure ( p:LongInt; Serie:PChar; Folio:PChar; Fecha:PChar; FormaDePago:PChar; CondicionesDePago:PChar; SubTotal:PChar; Descuento:PChar; Moneda:PChar; TipoCambio:PChar; Total:PChar; TipoDeComprobante:PChar; MetodoDePago:PChar; LugarExpedicion:PChar; Confirmacion:PChar; Exportacion:PChar ); cdecl;
  VirtualXML_SetInformacionGlobal_cfdi40 : procedure ( p:LongInt; Periodicidad:PChar; Meses:PChar; Anio:PChar ); cdecl;
  VirtualXML_SetReceptorInfo_cfdi40      : procedure ( p:LongInt; RFC:PChar; Nombre:PChar; ResidenciaFiscal:PChar; NumRegIdTrib:PChar; UsoCFDI:PChar; DomicilioFiscalReceptor:PChar; RegimenFiscalReceptor:PChar ); cdecl;
  VirtualXML_SetEmisorInfo_cfdi40        : procedure ( p:LongInt; RFC:PChar; Nombre:PChar; RegimenFiscal:PChar; FacAtrAdquirente:PChar ); cdecl;
  VirtualXML_AddConcepto_cfdi40          : procedure ( p:LongInt; ClaveProdServ:PChar; NoIdentificacion:PChar; Cantidad:PChar; ClaveUnidad:PChar; Unidad:PChar; Descripcion:PChar; ValorUnitario:PChar; Importe:PChar; Descuento:PChar; ObjetoImp:PChar ); cdecl;
  VirtualXML_AddConceptoTraslado_cfdi40  : procedure ( p:LongInt; Base:PChar; Impuesto:PChar; Tipofactor:PChar; TasaOCuota:PChar; Importe:PChar ); cdecl;
  VirtualXML_SetImpuestosInfo_cfdi40     : procedure ( p:LongInt; totalImpuestosTrasladados:PChar; totalImpuestosRetenidos:PChar ); cdecl;
  VirtualXML_AddTraslado_cfdi40          : procedure ( p:LongInt; Impuesto:PChar; TipoFactor:PChar; TasaOCuota:PChar; Importe:PChar; Base:PChar ); cdecl;
  VirtualXML_GetValue                    : function  ( p:LongInt; value:LongInt ): PChar; cdecl;
  VirtualXML_ProcesaDocumento            : function  ( p:LongInt; csd:PChar; key:PChar; keypwd:PChar; outfile:PChar ): LongInt; cdecl;
  VirtualXML_Free                        : procedure ( p:LongInt ); cdecl;

begin

  hBar := LoadLibrary( 'VirtualXML.dll' );

  VirtualXML_New                         := GetProcAddress ( Hbar, 'VirtualXML_New' );
  VirtualXML_SetVirtualPACInfo           := GetProcAddress ( Hbar, 'VirtualXML_SetVirtualPACInfo' );
  VirtualXML_SetComprobanteInfo_cfdi40   := GetProcAddress ( Hbar, 'VirtualXML_SetComprobanteInfo_cfdi40' );
  VirtualXML_SetInformacionGlobal_cfdi40 := GetProcAddress ( Hbar, 'VirtualXML_SetInformacionGlobal_cfdi40' );
  VirtualXML_SetReceptorInfo_cfdi40      := GetProcAddress ( Hbar, 'VirtualXML_SetReceptorInfo_cfdi40' );
  VirtualXML_SetEmisorInfo_cfdi40        := GetProcAddress ( Hbar, 'VirtualXML_SetEmisorInfo_cfdi40' );
  VirtualXML_AddConcepto_cfdi40          := GetProcAddress ( Hbar, 'VirtualXML_AddConcepto_cfdi40' );
  VirtualXML_AddConceptoTraslado_cfdi40  := GetProcAddress ( Hbar, 'VirtualXML_AddConceptoTraslado_cfdi40' );
  VirtualXML_SetImpuestosInfo_cfdi40     := GetProcAddress ( Hbar, 'VirtualXML_SetImpuestosInfo_cfdi40' );
  VirtualXML_AddTraslado_cfdi40          := GetProcAddress ( Hbar, 'VirtualXML_AddTraslado_cfdi40' );
  VirtualXML_GetValue                    := GetProcAddress ( Hbar, 'VirtualXML_GetValue' );
  VirtualXML_ProcesaDocumento            := GetProcAddress ( Hbar, 'VirtualXML_ProcesaDocumento' );
  VirtualXML_Free                        := GetProcAddress ( Hbar, 'VirtualXML_Free' );

   //* indicamos la nueva version 4.0 */
   hXml := VirtualXML_New('4.0');

   //* credenciales de timbrado */
   VirtualXML_SetVirtualPACInfo(hXml,'demo_cibertec','demo');

   //* Datos generales del comprobante*/
   VirtualXML_SetComprobanteInfo_cfdi40(hXml,'CJZ','7303','%cb_date','99','CREDITO','11500.00','0.00','MXN','1','13340.00','I','PPD','07270','','01');

   //* Aadir nodo de informacion global */
   VirtualXML_SetInformacionGlobal_cfdi40(hXml,'01','01','2022');

   //* datos del emisor */
   VirtualXML_SetEmisorInfo_cfdi40(hXml,'EKU9003173C9','ESCUELA KEMPER URGATE','601','');

   //* datos del receptor, para publico en general RFC: XAXX010101000, nombre: 'PUBLICO EN GENERAL' uso cfdi: 'S01' y el mismo CP que emision del CFDI   */
   VirtualXML_SetReceptorInfo_cfdi40(hXml,'XAXX010101000','PUBLICO EN GENERAL','','','S01','07270','616');

   //* agregamos conceptos */
   VirtualXML_AddConcepto_cfdi40(hXml,'01010101','TKT-001','1','ACT','','Venta','1000.00','1000.00','0.00','02');
   VirtualXML_AddConceptoTraslado_cfdi40(hXml,'1000.00','002','Tasa','0.160000','160.00');  // impuestos del concepto
   VirtualXML_AddConcepto_cfdi40(hXml,'01010101','TKT-002','1','ACT','','Venta','500.00','500.00','0.00','02');
   VirtualXML_AddConceptoTraslado_cfdi40(hXml,'500.00','002','Tasa','0.160000','80.00');  // impuestos del concepto
   VirtualXML_AddConcepto_cfdi40(hXml,'01010101','TKT-003','1','ACT','','Venta','10000.00','10000.00','0.00','02');
   VirtualXML_AddConceptoTraslado_cfdi40(hXml,'10000.00','002','Tasa','0.160000','1600.00');  // impuestos del concepto

   //* resumen de impuestos */
   VirtualXML_SetImpuestosInfo_cfdi40(hXml,'1840.00','');
   VirtualXML_AddTraslado_cfdi40(hXml,'002','Tasa','0.160000','1840.00','11500.00');

   //* generamos el CFDI */
   i := VirtualXML_ProcesaDocumento(hXml,'CSD_EKU9003173C9.cer','CSD_EKU9003173C9.key','12345678a','DemoIngresoCfdi40VentasDiarias.xml');

  if VirtualXML_GetValue(hXml, 1) = 'VIRTUALXML_OK' then
  begin
      application.MessageBox(VirtualXML_GetValue( hXML, 3),'No. de certificado del emisor' );
      application.MessageBox(VirtualXML_GetValue( hXML, 4),'Sello digital del emisor');
      application.MessageBox(VirtualXML_GetValue( hXML, 5),'Cadena original del documento');
      application.MessageBox(VirtualXML_GetValue( hXML, 6),'No. de certificado del SAT');
      application.MessageBox(VirtualXML_GetValue( hXML, 7),'Sello digital del timbre');
      application.MessageBox(VirtualXML_GetValue( hXML, 8),'Cadena original del timbre');
      application.MessageBox(VirtualXML_GetValue( hXML, 9),'UUID Folio fiscal');
      application.MessageBox(VirtualXML_GetValue( hXML, 10),'Fecha de generacion del timbre');
      application.MessageBox(VirtualXML_GetValue( hXML, 11),'Fecha de inicio de vigencia del certificado');
      application.MessageBox(VirtualXML_GetValue( hXML, 12),'Fecha de terminacion de vigencia del certificado');
      application.MessageBox(VirtualXML_GetValue( hXML, 13),'ID de operacion VirtualPAC');
      application.MessageBox(VirtualXML_GetValue( hXML, 14),'Cantidad de timbres disponbiles');
      application.MessageBox(VirtualXML_GetValue( hXML, 15),'Version de la libreria');
      application.MessageBox(VirtualXML_GetValue( hXML, 16),'Fecha de emision del XML');
      application.MessageBox(VirtualXML_GetValue( hXML, 17),'Mensaje del PAC');
      application.MessageBox(VirtualXML_GetValue( hXML, 18),'PAC que certifico el documento');
      application.MessageBox(VirtualXML_GetValue( hXML, 19),'No. de revision de la libreria');
      application.MessageBox(VirtualXML_GetValue( hXML, 20),'RFC del proveedor de certificacion');
      application.MessageBox(VirtualXML_GetValue( hXML, 21),'Leyenda del PAC');
    end
    else
      application.MessageBox(VirtualXML_GetValue( hXML, 2),'Descripcion del error');

    VirtualXML_Free(hXML);

  FreeLibrary(Hbar);

end;

// CFDI 4.0 Publico en General (venta de mostrador)
procedure TForm1.Button7Click(Sender: TObject);
var
  i: Integer;
  hXml: LongInt;
  hBar: Thandle;

  VirtualXML_New                        : function  ( szVersion:PChar ): LongInt; cdecl;
  VirtualXML_SetVirtualPACInfo          : procedure ( p:LongInt; szUser:PChar; servidor:PChar ); cdecl;
  VirtualXML_SetComprobanteInfo_cfdi40  : procedure ( p:LongInt; Serie:PChar; Folio:PChar; Fecha:PChar; FormaDePago:PChar; CondicionesDePago:PChar; SubTotal:PChar; Descuento:PChar; Moneda:PChar; TipoCambio:PChar; Total:PChar; TipoDeComprobante:PChar; MetodoDePago:PChar; LugarExpedicion:PChar; Confirmacion:PChar; Exportacion:PChar ); cdecl;
  VirtualXML_SetReceptorInfo_cfdi40     : procedure ( p:LongInt; RFC:PChar; Nombre:PChar; ResidenciaFiscal:PChar; NumRegIdTrib:PChar; UsoCFDI:PChar; DomicilioFiscalReceptor:PChar; RegimenFiscalReceptor:PChar ); cdecl;
  VirtualXML_SetEmisorInfo_cfdi40       : procedure ( p:LongInt; RFC:PChar; Nombre:PChar; RegimenFiscal:PChar; FacAtrAdquirente:PChar ); cdecl;
  VirtualXML_AddConcepto_cfdi40         : procedure ( p:LongInt; ClaveProdServ:PChar; NoIdentificacion:PChar; Cantidad:PChar; ClaveUnidad:PChar; Unidad:PChar; Descripcion:PChar; ValorUnitario:PChar; Importe:PChar; Descuento:PChar; ObjetoImp:PChar ); cdecl;
  VirtualXML_AddConceptoTraslado_cfdi40 : procedure ( p:LongInt; Base:PChar; Impuesto:PChar; Tipofactor:PChar; TasaOCuota:PChar; Importe:PChar ); cdecl;
  VirtualXML_SetImpuestosInfo_cfdi40    : procedure ( p:LongInt; totalImpuestosTrasladados:PChar; totalImpuestosRetenidos:PChar ); cdecl;
  VirtualXML_AddTraslado_cfdi40         : procedure ( p:LongInt; Impuesto:PChar; TipoFactor:PChar; TasaOCuota:PChar; Importe:PChar; Base:PChar ); cdecl;
  VirtualXML_GetValue                   : function  ( p:LongInt; value:LongInt ): PChar; cdecl;
  VirtualXML_ProcesaDocumento           : function  ( p:LongInt; csd:PChar; key:PChar; keypwd:PChar; outfile:PChar ): LongInt; cdecl;
  VirtualXML_Free                       : procedure ( p:LongInt ); cdecl;

begin

  hBar := LoadLibrary( 'VirtualXML.dll' );

  VirtualXML_New                         := GetProcAddress ( Hbar, 'VirtualXML_New' );
  VirtualXML_SetVirtualPACInfo           := GetProcAddress ( Hbar, 'VirtualXML_SetVirtualPACInfo' );
  VirtualXML_SetComprobanteInfo_cfdi40   := GetProcAddress ( Hbar, 'VirtualXML_SetComprobanteInfo_cfdi40' );
  VirtualXML_SetReceptorInfo_cfdi40      := GetProcAddress ( Hbar, 'VirtualXML_SetReceptorInfo_cfdi40' );
  VirtualXML_SetEmisorInfo_cfdi40        := GetProcAddress ( Hbar, 'VirtualXML_SetEmisorInfo_cfdi40' );
  VirtualXML_AddConcepto_cfdi40          := GetProcAddress ( Hbar, 'VirtualXML_AddConcepto_cfdi40' );
  VirtualXML_AddConceptoTraslado_cfdi40  := GetProcAddress ( Hbar, 'VirtualXML_AddConceptoTraslado_cfdi40' );
  VirtualXML_SetImpuestosInfo_cfdi40     := GetProcAddress ( Hbar, 'VirtualXML_SetImpuestosInfo_cfdi40' );
  VirtualXML_AddTraslado_cfdi40          := GetProcAddress ( Hbar, 'VirtualXML_AddTraslado_cfdi40' );
  VirtualXML_GetValue                    := GetProcAddress ( Hbar, 'VirtualXML_GetValue' );
  VirtualXML_ProcesaDocumento            := GetProcAddress ( Hbar, 'VirtualXML_ProcesaDocumento' );
  VirtualXML_Free                        := GetProcAddress ( Hbar, 'VirtualXML_Free' );

   //* indicamos la nueva version 4.0 */
   hXml := VirtualXML_New('4.0');

   //* credenciales de timbrado */
   VirtualXML_SetVirtualPACInfo(hXml,'demo_cibertec','demo');

   //* Datos generales del comprobante*/
   VirtualXML_SetComprobanteInfo_cfdi40(hXml,'CJZ','7303','%cb_date','99','CREDITO','6034.48','0.00','MXN','1','7000.00','I','PPD','07270','','01');
   //* datos del emisor */
   VirtualXML_SetEmisorInfo_cfdi40(hXml,'EKU9003173C9','ESCUELA KEMPER URGATE','601','');

   //* datos del receptor, para publico en general RFC: XAXX010101000, cualquier nombre QUE NO SEA 'PUBLICO EN GENERAL' uso cfdi: 'S01' y el mismo CP que emision del CFDI   */
   VirtualXML_SetReceptorInfo_cfdi40(hXml,'XAXX010101000','PONER CUALQUIER NOMBRE AQUI','','','S01','07270','616');

   //* agregamos conceptos */
   VirtualXML_AddConcepto_cfdi40(hXml,'43211500','EQU-0025','1.000','H87','Computadora','COMPUTADORA HP PORTATIL','6034.48','6034.48','0.00','02');
   VirtualXML_AddConceptoTraslado_cfdi40(hXml,'6034.48','002','Tasa','0.160000','965.52');  // impuestos del concepto

   //* resumen de impuestos */
   VirtualXML_SetImpuestosInfo_cfdi40(hXml,'965.52','');
   VirtualXML_AddTraslado_cfdi40(hXml,'002','Tasa','0.160000','965.52','6034.48');

   //* generamos el CFDI */
   i := VirtualXML_ProcesaDocumento(hXml,'CSD_EKU9003173C9.cer','CSD_EKU9003173C9.key','12345678a','DemoIngresoCfdi40PublicoGeneral.xml');

  if VirtualXML_GetValue(hXml, 1) = 'VIRTUALXML_OK' then
  begin
      application.MessageBox(VirtualXML_GetValue( hXML, 3),'No. de certificado del emisor' );
      application.MessageBox(VirtualXML_GetValue( hXML, 4),'Sello digital del emisor');
      application.MessageBox(VirtualXML_GetValue( hXML, 5),'Cadena original del documento');
      application.MessageBox(VirtualXML_GetValue( hXML, 6),'No. de certificado del SAT');
      application.MessageBox(VirtualXML_GetValue( hXML, 7),'Sello digital del timbre');
      application.MessageBox(VirtualXML_GetValue( hXML, 8),'Cadena original del timbre');
      application.MessageBox(VirtualXML_GetValue( hXML, 9),'UUID Folio fiscal');
      application.MessageBox(VirtualXML_GetValue( hXML, 10),'Fecha de generacion del timbre');
      application.MessageBox(VirtualXML_GetValue( hXML, 11),'Fecha de inicio de vigencia del certificado');
      application.MessageBox(VirtualXML_GetValue( hXML, 12),'Fecha de terminacion de vigencia del certificado');
      application.MessageBox(VirtualXML_GetValue( hXML, 13),'ID de operacion VirtualPAC');
      application.MessageBox(VirtualXML_GetValue( hXML, 14),'Cantidad de timbres disponbiles');
      application.MessageBox(VirtualXML_GetValue( hXML, 15),'Version de la libreria');
      application.MessageBox(VirtualXML_GetValue( hXML, 16),'Fecha de emision del XML');
      application.MessageBox(VirtualXML_GetValue( hXML, 17),'Mensaje del PAC');
      application.MessageBox(VirtualXML_GetValue( hXML, 18),'PAC que certifico el documento');
      application.MessageBox(VirtualXML_GetValue( hXML, 19),'No. de revision de la libreria');
      application.MessageBox(VirtualXML_GetValue( hXML, 20),'RFC del proveedor de certificacion');
      application.MessageBox(VirtualXML_GetValue( hXML, 21),'Leyenda del PAC');
    end
    else
      application.MessageBox(VirtualXML_GetValue( hXML, 2),'Descripcion del error');

    VirtualXML_Free(hXML);

  FreeLibrary(Hbar);


end;

procedure TForm1.Button8Click(Sender: TObject);
var
  nResult: Integer;
  hBar: Thandle;

  VirtualXML_MicroValidaDatosFiscales : function ( apikey:PChar; usuario:PChar; rfcemisor:PChar; rfcreceptor:PChar; nombre:PChar; regimenfiscal:PChar; CodigoPostal:PChar; csdcer:PChar; csdkey:PChar; pwdkey:PChar; ResultFile:PChar; OutLog:PChar; Reserved:PChar ): LongInt; cdecl;

begin
 hBar := LoadLibrary( 'VirtualXML.dll' );

  VirtualXML_MicroValidaDatosFiscales :=  GetProcAddress ( Hbar, 'VirtualXML_MicroValidaDatosFiscales' );

   // caso 1. Los datos fiscales son correctos
   nResult := VirtualXML_MicroValidaDatosFiscales ('VRW5TGMnvMiyIGK7FxkYHb0ebytvoZMWgpYUnJ63Mkc', 'Microservices', 'EKU9003173C9', 'TCH850701RM1', 'TIENDAS CHEDRAUI', '601', '11950', 'CSD_EKU9003173C9.cer', 'CSD_EKU9003173C9.key','12345678a','ValidadoOK.INI', 'ValidadoOK.LOG','');
   if nResult = 0 then  // datos correctamente validados
    begin
      application.MessageBox('Revise el archivo ValidadorOK.ini','Datos correctamente validados');
    end
   else  // error de validacion.
      application.MessageBox('Revise el archivo ValidadorOK.log','Error de validacin de datos');

   // caso 2. Datos "parcialmente correctos", los datos son incorrectos, pero tenemos los datos fiscales en la base de datos */
   nResult := VirtualXML_MicroValidaDatosFiscales ('VRW5TGMnvMiyIGK7FxkYHb0ebytvoZMWgpYUnJ63Mkc', 'Microservices', 'EKU9003173C9', 'NWM9709244W4', 'WALMART', '601', '11950', 'CSD_EKU9003173C9.cer', 'CSD_EKU9003173C9.key','12345678a','ValidadoErrorParcial.INI', 'ValidadoErrorParcial.LOG','');
   if nResult = 1 then
    begin
      application.MessageBox('Datos Proporcionados incorrectos, pero tenemos los datos fiscales correctos','Revise el archivo ValidadoErrorParcial.INI');
    end
    else
      application.MessageBox('Revise el archivo ValidadorOK.log','Error de validacin de datos');

   //  caso 3. Datos fiscales son incorrectos y no hay informacin fiscal en la base de datos */
   nResult := VirtualXML_MicroValidaDatosFiscales ('VRW5TGMnvMiyIGK7FxkYHb0ebytvoZMWgpYUnJ63Mkc', 'Microservices', 'EKU9003173C9', 'FOLR670417KD6', 'RAUL FLORES LANUS', '605', '07270', 'CSD_EKU9003173C9.cer', 'CSD_EKU9003173C9.key','12345678a','ValidadoError.INI', 'ValidadoError.LOG','');
   if nResult = -1 then
    begin
      application.MessageBox('No se encontraron datos fiscales, revise el archivo ValidadoError.log','Error de validacion');
    end;
end;

procedure TForm1.Button9Click(Sender: TObject);
var
  nResult: Integer;
  hBar: Thandle;

  VirtualXML_MicroConsultaDatosFiscales : function ( apikey:PChar; usuario:PChar; rfcemisor:PChar; rfcreceptor:PChar; csdcer:PChar; csdkey:PChar; pwdkey:PChar; ResultFile:PChar; OutLog:PChar; Reserved:PChar ): LongInt; cdecl;

begin
  hBar := LoadLibrary( 'VirtualXML.dll' );

  VirtualXML_MicroConsultaDatosFiscales :=  GetProcAddress ( Hbar, 'VirtualXML_MicroConsultaDatosFiscales' );

   // caso 1. Busqueda exitosa
   nResult := VirtualXML_MicroConsultaDatosFiscales ('VRW5TGMnvMiyIGK7FxkYHb0ebytvoZMWgpYUnJ63Mkc', 'Microservices', 'EKU9003173C9', 'NES220325179', 'CSD_EKU9003173C9.cer', 'CSD_EKU9003173C9.key','12345678a','ConsultaOK.INI', 'ConsultaOK.LOG','');
   if nResult = 0 then  // datos correctamente validados
    begin
      application.MessageBox('Revise el archivo ConsultaOK.ini','Datos Fiscales Encontrados');
    end
   else  // error de validacion.
      application.MessageBox('Revise el archivo ConsultaOK.log','No tenemos informacin del RFC');

   // caso 2. Busqueda no exitosa
   nResult := VirtualXML_MicroConsultaDatosFiscales ('VRW5TGMnvMiyIGK7FxkYHb0ebytvoZMWgpYUnJ63Mkc', 'Microservices', 'EKU9003173C9', 'LODJ360912Q76', 'CSD_EKU9003173C9.cer', 'CSD_EKU9003173C9.key','12345678a','ConsultaError.INI', 'ConsultaError.LOG','');
   application.MessageBox('Revise el archivo ConsultaOK.LOG','No tenemos informacin del RFC');


end;

end.

{
 todos los wrappers
 VirtualXML_New : function                                                           ( szVersion:PChar ): LongInt; cdecl;
 VirtualXML_ProcesaDocumento : function                                              ( p:LongInt; csd:PChar; key:PChar; keypwd:PChar; outfile:PChar ): LongInt; cdecl;
 VirtualXML_ProcesaDocumentoSSL : function                                           ( p:LongInt; csd:PChar; key:PChar; keypwd:PChar; outfile:PChar ): LongInt; cdecl;
 VirtualXML_GetValue : function                                                      ( p:LongInt; value:LongInt ): PChar; cdecl;
 VirtualXML_GetTimeWithDelay : function                                              ( p:LongInt; nSegs:LongInt ): PChar; cdecl;
 VirtualXML_CancelaUUID : function                                                   ( szUser:PChar; szEmisor:PChar; szCert:PChar; szKey:PChar; szPwd:PChar; szUuid:PChar; szOut:PChar ): LongInt; cdecl;
 VirtualXML_CancelaCFDI : function                                                   ( szUser:PChar; szEmisor:PChar; szReceptor:PChar; szTotal:PChar; szUuid:PChar; szCert:PChar; szKey:PChar; szPwd:PChar; szResult:PChar; szLog:PChar ): LongInt; cdecl;
 VirtualXML_GetStatusCFDI : function                                                 ( szUser:PChar; szEmisor:PChar; szReceptor:PChar; szTotal:PChar; szUuid:PChar; szResult:PChar; szLog:PChar ): LongInt; cdecl;
 VirtualXML_RecuperaAcuseCancelacion: function                                       ( sZUser:PChar; sZemisor:PChar; SzUuid:PChar; sZResult:PChar; szXMLAcuse:PChar; szLog:PChar; sZreserved:PChar ): LongInt; cdecl;
 VirtualXML_CerKeyMatch : function                                                   ( p:LongInt; szEmisor:PChar; szCSD:PChar; szKey:PChar; szKeyPwd:PChar ): LongInt; cdecl;
 VirtualXML_CheckLicence : function                                                  ( user:PChar; llave:PChar; emisor:PChar ): LongInt; cdecl;
 VirtualXML_CheckFile : function                                                     ( szFile:PChar ): LongInt; cdecl;
 VirtualXML_Load : function                                                          ( Archivo:PChar ): LongInt; cdecl;
 VirtualXML_CerTo64 : function                                                       ( ArchivoCer:PChar ): PChar; cdecl;
 VirtualXML_FileTo64 : function                                                      ( Archivo:PChar ): PChar; cdecl;
 VirtualXML_ConsultaSaldos: function                                                 ( usuario:PChar; rfcEmisor:PChar; DatoSolicitado:LongInt; ArchivoLog:PChar ): LongInt; cdecl;
 VirtualXML_FirmaSellaDocto : function                                               ( p:LongInt; csd:PChar; key:PChar; keypwd:PChar; outfile:PChar ): LongInt; cdecl;
 VirtualXML_ConsultaEstadoCFDI: function                                             ( rfcEmisor :PChar; rfcReceptor:PChar; Total:PChar; UUID:PChar; OutLog:PChar ): LongInt; cdecl;
 VirtualXML_GeneraCBB: function                                                      ( Datos:PChar; Archivo:PChar; Dependencias:LongInt; RutaLog:PChar; AddLog:LongInt; Escala:LongInt; Margen:LongInt ): LongInt ; cdecl;
 VirtualXML_MasivaDescarga: function                                                 ( Usuario:PChar; ArchivoCerFiel:PChar; ArchivoKeyFiel:PChar; PwdKey:PChar; IdPaquete:PChar; ArchivoDescargado:PChar; ArchLog:PChar; Reservado:PChar ): LongInt; cdecl;
 VirtualXML_MasivaSolicitaEmitidoXML: function                                       ( Usuario:PChar; ArchivoCerFiel:PChar; ArchivoKeyFiel:PChar; PwdKey:PChar; RfcReceptor:PChar; FechaDesde:PChar; FechaHasta:PChar; ArchResultado:PChar; ArchLog:PChar; Reservado:PChar ): LongInt; cdecl;
 VirtualXML_MasivaSolicitaEmitidoMetadata: function                                  ( Usuario:PChar; ArchivoCerFiel:PChar; ArchivoKeyFiel:PChar; PwdKey:PChar; RfcReceptor:PChar; FechaDesde:PChar; FechaHasta:PChar; ArchResultado:PChar; ArchLog:PChar; Reservado:PChar ): LongInt; cdecl;
 VirtualXML_MasivaSolicitaRecibidoXML: function                                      ( Usuario:PChar; ArchivoCerFiel:PChar; ArchivoKeyFiel:PChar; PwdKey:PChar; RfcEmisor:PChar; FechaDesde:PChar; FechaHasta:PChar; ArchResultado:PChar; ArchLog:PChar; Reservado:PChar ): LongInt; cdecl;
 VirtualXML_MasivaSolicitaRecibidoMetadata: function                                 ( Usuario:PChar; ArchivoCerFiel:PChar; ArchivoKeyFiel:PChar; PwdKey:PChar; RfcEmisor:PChar; FechaDesde:PChar; FechaHasta:PChar; ArchResultado:PChar; ArchLog:PChar; Reservado:PChar ): LongInt; cdecl;
 VirtualXML_MasivaVerifica: function                                                 ( Usuario:PChar; ArchivoCerFiel:PChar; ArchivoKeyFiel:PChar; PwdKey:PChar; IdSolicitud:PChar; ArchResultado:PChar; ArchLog:PChar; Reservado:PChar ): LongInt; cdecl;
 VirtualXML_Free : procedure                                                         ( p:LongInt ); cdecl;
 VirtualXML_SetVirtualPACInfo : procedure                                            ( p:LongInt; szUser:PChar; servidor:PChar ); cdecl;
 VirtualXML_SetCiberSATInfo : procedure                                              ( p:LongInt; userCiberPAC:PChar; llaveCiberPAC:PChar ); cdecl;
 VirtualXML_SetComprobanteInfo : procedure                                           ( p:LongInt; serie:PChar; folio:PChar; fecha:PChar; tipoDeComprobante:PChar; formaDePago:PChar; subtotal:PChar; descuento:PChar; total:PChar; moneda:PChar; tipoCambio:PChar; condicionesDePago:PChar; metodoDePago:PChar; motivoDescuento:PChar ); cdecl;
 VirtualXML_SetImpuestosLocalesInfo : procedure                                      ( p:LongInt; TotaldeTraslados:PChar; TotaldeRetenciones:PChar ); cdecl;
 VirtualXML_AddImpuestoLocalRetenido : procedure                                     ( p:LongInt; ImpLocRetenido:PChar; TasadeRetencion:PChar; Importe:PChar ); cdecl;
 VirtualXML_AddImpuestoLocalTrasladado : procedure                                   ( p:LongInt; ImpLocTrasladado:PChar; TasadeTraslado:PChar; Importe:PChar ); cdecl;
 VirtualXML_AddDonatarias11 : procedure                                              ( p:LongInt; noAutorizacion:PChar; fechaAutorizacion:PChar; leyenda:PChar ); cdecl;
 VirtualXML_SetDllPath : procedure                                                   ( p:LongInt; DllPath:PChar ); cdecl;
 VirtualXML_GetValueInFile : procedure                                               ( p:LongInt; value:LongInt; archivo:PChar ); cdecl;
 VirtualXML_ProcessFile : procedure                                                  ( szFile:PChar ); cdecl;
 VirtualXML_SetLogFile : procedure                                                   ( p:LongInt; archivo:PChar ); cdecl;
 VirtualXML_ShowValue : procedure                                                    ( p:LongInt; lValue:LongInt; title:PChar ); cdecl;
 VirtualXML_Save : procedure                                                         ( p:LongInt; archivo:PChar ); cdecl;
 VirtualXML_GetValues : procedure                                                    ( p:LongInt; archivo:PChar; lFormat:LongInt ); cdecl;
 VirtualXML_SetNomina12: procedure                                                   ( p:LongInt; TipoNomina:PChar; FechaPago:PChar; FechaInicialPago:PChar; FechaFinalPago:PChar; NumDiasPagados:PChar; TotalPercepciones:PChar; TotalDeducciones:PChar; TotalOtrosPagos:PChar ); cdecl;
 VirtualXML_Nomina12SetEmisor: procedure                                             ( p:LongInt; Curp:PChar; RegistroPatronal:PChar; RfcPatronOrigen:PChar; OrigenRecurso:PChar; MontoRecursoPropio :PChar ); cdecl;
 VirtualXML_Nomina12SetReceptor: procedure                                           ( p:LongInt; Curp:PChar; NumSeguridadSocial:PChar; FechaInicioRelLaboral:PChar; Antiguedad:PChar; TipoContrato:PChar; Sindicalizado:PChar; TipoJornada:PChar; TipoRegimen:PChar; NumEmpleado:PChar; Departamento:PChar; Puesto:PChar; RiesgoPuesto:PChar; PeriodicidadPago:PChar; Banco:PChar; CuentaBancaria:PChar; SalarioBaseCotApor:PChar;  SalarioDiarioIntegrado:PChar;  ClaveEntFed:PChar ); cdecl;
 VirtualXML_Nomina12AddSubContratacion: procedure                                    ( p:LongInt; RfcLabora:PChar; PorcentajeTiempo:PChar ); cdecl;
 VirtualXML_Nomina12SetPercepciones: procedure                                       ( p:LongInt; TotalSueldos:PChar; TotalSeparacionIndemnizacion:PChar; TotalJubilacionPensionRetiro:PChar; TotalGravado:PChar; TotalExento:PChar ); cdecl;
 VirtualXML_Nomina12AddPercepcion: procedure                                         ( p:LongInt; TipoPercepcion:PChar; Clave:PChar; Concepto:PChar; ImporteGravado:PChar; ImporteExento:PChar; Dias:PChar; TipoHoras:PChar; HorasExtra:PChar; ImportePagado:PChar; ValorMercado:PChar; PrecioAlOtorgarse:PChar ); cdecl;
 VirtualXML_Nomina12SetJubilacionPensionRetiro: procedure                            ( p:LongInt; TotalUnaExhibicion:PChar; TotalParcialidad:PChar; MontoDiario:PChar; IngresoAcumulable:PChar; IngresoNoAcumulable:PChar ); cdecl;
 VirtualXML_Nomina12SetSeparacionIndemnizacion: procedure                            ( p:LongInt; TotalPagado:PChar; NumAniosServicio:PChar; UltimoSueldoMensOrd:PChar; IngresoAcumulable:PChar; IngresoNoAcumulable:PChar ); cdecl;
 VirtualXML_Nomina12SetDeducciones: procedure                                        ( p:LongInt; TotalOtrasDeducciones:PChar; TotalImpuestosRetenidos:PChar ); cdecl;
 VirtualXML_Nomina12AddDeduccion: procedure                                          ( p:LongInt; TipoDeduccion:PChar; Clave:PChar; Concepto:PChar; Importe:PChar ); cdecl;
 VirtualXML_Nomina12AddOtroPago: procedure                                           ( p:LongInt; TipoOtroPago:PChar; Clave:PChar; Concepto:PChar; Importe:PChar; SaldoAFavor:PChar; Anio:PChar; RemanenteSalFav:PChar; SubsidioCausado:PChar ); cdecl;
 VirtualXML_Nomina12AddIncapacidad: procedure                                        ( p:LongInt; DiasIncapacidad:PChar; TipoIncapacidad:PChar; ImporteMonetario:PChar ); cdecl;
 VirtualXML_SetCompleteXML_cfdi33: procedure                                         ( p:LongInt; XMLCompleto:PChar ); cdecl;
 VirtualXML_SetCfdiRelacionados_cfdi33: procedure                                    ( p:LongInt; TipoRelacion:PChar ); cdecl;
 VirtualXML_AddConceptoCuentaPredial_cfdi33: procedure                               ( p:LongInt; Numero:PChar ); cdecl ;
 VirtualXML_AddConceptoInformacionAduanera_cfdi33: procedure                         ( p:LongInt; NumeroPedimento:PChar ); cdecl;
 VirtualXML_SetAddendaText_cfdi33: procedure                                         ( p:LongInt; text:PChar ); cdecl;
 VirtualXML_AddComplemento_cfdi33: procedure                                         ( p:LongInt; complementoXml:PChar ); cdecl;
 VirtualXML_SetAddenda_cfdi33: procedure                                             ( p:LongInt; text:PChar ); cdecl;
 VirtualXML_AddEntidadContabilidad: procedure                                        ( p:LongInt; IdContabilidad:PChar ); cdecl;
 VirtualXML_AddCfdiRelacionado_cfdi33: procedure                                     ( p:LongInt; UUID:PChar ); cdecl;
 VirtualXML_CartaPorte10SetFiguraTransporte: procedure                               ( p:LongInt; CveTransporte:PChar ); cdecl;
 VirtualXML_SetImpuestosInfo_cfdi33: procedure                                       ( p:LongInt; TotalImpuestosTrasladados:PChar; TotalImpuestosRetenidos:PChar ); cdecl;
 VirtualXML_AddRetencion_cfdi33: procedure                                           ( p:LongInt; Impuesto:PChar; Importe:PChar ); cdecl;
 VirtualXML_SetEmisorInfo_cfdi33: procedure                                          ( p:LongInt; Rfc:PChar; Nombre:PChar; RegimenFiscal:PChar ); cdecl;
 VirtualXML_AddEntidad: procedure                                                    ( p:LongInt; ClaveEntidad:PChar; Ambito:PChar; IdContabilidad:PChar ); cdecl;
 VirtualXML_SetLeyendasFiscales10: procedure                                         ( p:LongInt; Disposicion:PChar; Norma:PChar; TextoLeyenda:PChar ); cdecl;
 VirtualXML_AddTraslado_cfdi33: procedure                                            ( p:LongInt; Impuesto:PChar; TipoFactor:PChar; TasaOCuota:PChar; Importe:PChar ); cdecl;
 VirtualXML_SetReceptorInfo_cfdi33: procedure                                        ( p:LongInt; Rfc:PChar; Nombre:PChar; ResidenciaFiscal:PChar; NumRegIdTrib:PChar; UsoCFDI:PChar ); cdecl;
 VirtualXML_AddConceptoTraslado_cfdi33: procedure                                    ( p:LongInt; Base:PChar; Impuesto:PChar; TipoFactor:PChar; TasaOCuota:PChar; Importe:PChar ); cdecl;
 VirtualXML_AddConceptoRetencion_cfdi33: procedure                                   ( p:LongInt; Base:PChar; Impuesto:PChar; TipoFactor:PChar; TasaOCuota:PChar; Importe:PChar ); cdecl;
 VirtualXML_AddConceptoComplementoIedu_cfdi33: procedure                             ( p:LongInt; nombreAlumno:PChar; CURP:PChar; nivelEducativo:PChar; autRVOE:PChar; rfcPago:PChar ); cdecl;
 VirtualXML_SetINE11: procedure                                                      ( p:LongInt; TipoProceso:PChar; TipoComite:PChar; IdContabilidad:PChar; ClaveEntidad:PChar; Ambito:PChar; EntidadContabilidadIdContabilidad:PChar ); cdecl;
 VirtualXML_AddConceptoParte_cfdi33: procedure                                       ( p:LongInt; ClaveProdServ:PChar; NoIdentificacion:PChar; Cantidad:PChar; Unidad:PChar; Descripcion:PChar; ValorUnitario:PChar; Importe:PChar; NumeroPedimento:PChar ); cdecl;
 VirtualXML_AddConcepto_cfdi33: procedure                                            ( p:LongInt; ClaveProdServ:PChar; NoIdentificacion:PChar; Cantidad:PChar; ClaveUnidad:PChar; Unidad:PChar; Descripcion:PChar; ValorUnitario:PChar; Importe:PChar; Descuento:PChar ); cdecl;
 VirtualXML_SetServicioParcial10: procedure                                          ( p:LongInt; NumPerLicoAut:PChar; Calle:PChar; NoExterior:PChar; NoInterior:PChar; Colonia:PChar; Localidad:PChar; Referencia:PChar; Municipio:PChar; Estado:PChar; CodigoPostal:PChar ); cdecl;
 VirtualXML_SetPagos10: procedure                                                    ( p:LongInt ); cdecl ;
 VirtualXML_Pagos10AddPagoDoctoRelacionado: procedure                                ( p:LongInt; IdDocumento:PChar; Serie:PChar; Folio:PChar; MonedaDR:PChar; TipoCambioDR:PChar; MetodoDePagoDR:PChar; NumParcialidad:PChar; ImpSaldoAnt:PChar; ImpPagado:PChar; ImpSaldoInsoluto:PChar ); cdecl;
 VirtualXML_Pagos10SetPago: procedure                                                ( p:LongInt; FechaPago:PChar; FormaDePago:PChar; MonedaP:PChar; TipoCambioP:PChar; Monto:PChar; NumOperacion:PChar; RfcEmisorCtaOrd:PChar; NomBancoOrdExt:PChar; CtaOrdenante:PChar; RfcEmisorCtaBen:PChar; CtaBeneficiario:PChar; TipoCadPago:PChar; CertPago:PChar;  CadPago:PChar; SelloPago:PChar ); cdecl;
 VirtualXML_SetComercioExterior11: procedure                                         ( p:LongInt; MotivoTraslado:PChar; TipoOperacion:PChar; ClaveDePedimento:PChar; CertificadoOrigen:PChar; NumCertificadoOrigen:PChar; NumeroExportadorConfiable:PChar;  Incoterm:PChar;  Subdivision:PChar; Observaciones:PChar;  TipoCambioUSD:PChar; TotalUSD:PChar ); cdecl;
 VirtualXML_CCE11AddMercancia: procedure                                             ( p:LongInt; NoIdentificacion:PChar; FraccionArancelaria:PChar; CantidadAduana:PChar; UnidadAduana:PChar; ValorUnitarioAduana:PChar; ValorDolares:PChar;  Marca:PChar; Modelo:PChar; SubModelo:PChar; NumeroSerie:PChar ); cdecl;
 VirtualXML_CCE11SetEmisor: procedure                                                ( p:LongInt; Curp:PChar; Calle:PChar; NumeroExterior:PChar; NumeroInterior:PChar; Colonia:PChar; Localidad:PChar;  Referencia:PChar;  Municipio:PChar; Estado:PChar;  Pais:PChar; CodigoPostal:PChar ); cdecl;
 VirtualXML_CCE11SetReceptor: procedure                                              ( p:LongInt; NumRegIdTrib:PChar; Calle:PChar; NumeroExterior:PChar; NumeroInterior:PChar; Colonia:PChar; Localidad:PChar;  Referencia:PChar;  Municipio:PChar; Estado:PChar;  Pais:PChar; CodigoPostal:PChar ); cdecl;
 VirtualXML_CCE11AddDestinatario: procedure                                          ( p:LongInt; NumRegIdTrib:PChar; Nombre:PChar; Calle:PChar; NumeroExterior:PChar; NumeroInterior:PChar; Colonia:PChar; Localidad:PChar; Referencia:PChar; Municipio:PChar; Estado:PChar; Pais:PChar; CodigoPostal:PChar ); cdecl;
 VirtualXML_CCE11AddPropietario: procedure                                           ( p:LongInt; NumRegIdTrib:PChar; ResidenciaFiscal:PChar ); cdecl;
 VirtualXML_CCE11AddMercanciaDescripcionesEspecificas: procedure                     ( p:LongInt; Marca:PChar; Modelo:PChar; SubModelo:PChar; NumeroSerie:PChar ); cdecl;
 VirtualXML_SetComprobanteInfo_cfdi33: procedure                                     ( p:LongInt; Serie:PChar; Folio:PChar; Fecha:PChar; FormaPago:PChar; CondicionesDePago:PChar; SubTotal:PChar; Descuento:PChar; Moneda:PChar; TipoCambio:PChar; Total:PChar; TipoDeComprobante:PChar; MetodoPago:PChar; LugarExpedicion:PChar;  Confirmacion:PChar ); cdecl;
 VirtualXML_SetCartaPorte20: procedure		                              		         ( p:LongInt; TranspInternac:PChar; EntradaSalidaMerc:PChar; PaisOrigenDestino:PChar;  ViaEntradaSalida:PChar; TotalDistRec:PChar);cdecl;
 VirtualXML_CartaPorte20AddUbicacion: procedure					                             ( p:LongInt; TipoUbicacion:PChar; IDUbicacion:PChar; RFCRemitenteDestinatario:PChar; NombreRemitenteDestinatario:PChar; NumRegIdTrib:PChar; ResidenciaFiscal:PChar; NumEstacion:PChar; NombreEstacion:PChar; NavegacionTrafico:PChar; FechaHoraSalidaLlegada:PChar; TipoEstacion:PChar; DistanciaRecorrida:PChar; Calle:PChar; NumeroExterior:PChar; NumeroInterior:PChar; Colonia:PChar; Localidad:PChar; Referencia:PChar; Municipio:PChar; Estado:PChar; Pais:PChar; CodigoPostal:PChar);cdecl;
 VirtualXML_CartaPorte20SetMercancias: procedure 				                             ( p:LongInt; PesoBrutoTotal:PChar; UnidadPeso:PChar; PesoNetoTotal:PChar; NumTotalMercancias:PChar; CargoPorTasacion:PChar);cdecl;
 VirtualXML_CartaPorte20AddMercancia: procedure					                             ( p:LongInt; BienesTransp:PChar; ClaveSTCC:PChar; Descripcion:PChar; Cantidad:PChar; ClaveUnidad:PChar; Unidad:PChar; Dimensiones:PChar; MaterialPeligroso:PChar; CveMaterialPeligroso:PChar; Embalaje:PChar; DescripEmbalaje:PChar; PesoEnKg:PChar; ValorMercancia:PChar; Moneda:PChar; FraccionArancelaria:PChar; UUIDComercioExt:PChar; UnidadPesoMerc:PChar; PesoBruto:PChar; PesoNeto:PChar; PesoTara:PChar; NumPiezas:PChar);cdecl;
 VirtualXML_CartaPorte20AddMercanciaPedimentos: procedure			                       ( p:LongInt; Pedimento:PChar);cdecl;
 VirtualXML_CartaPorte20AddMercanciaGuiasIdentificacion: procedure		               ( p:LongInt; NumeroGuiaIdentificacion:PChar; DescripGuiaIdentificacion:PChar; PesoGuiaIdentificacion:PChar);cdecl;
 VirtualXML_CartaPorte20AddMercanciaCantidadTransporta: procedure		                 ( p:LongInt; Cantidad:PChar; IDOrigen:PChar; IDDestino:PChar; CvesTransporte:PChar);cdecl;
 VirtualXML_CartaPorte20SetMercanciasAutotransporte: procedure			                 ( p:LongInt; PermSCT:PChar; NumPermisoSCT:PChar; ConfigVehicular:PChar; PlacaVM:PChar; AnioModeloVM:PChar; AseguraRespCivil:PChar; PolizaRespCivil:PChar; AseguraMedAmbiente:PChar; PolizaMedAmbiente:PChar; AseguraCarga:PChar; PolizaCarga:PChar; PrimaSeguro:PChar; SubTipoRem1:PChar; Placa1:PChar; SubTipoRem2:PChar; Placa2:PChar); cdecl;
 VirtualXML_CartaPorte20SetMercanciasTransporteMaritimo: procedure		               ( p:LongInt; PermSCT:PChar; NumPermisoSCT:PChar; NombreAseg:PChar; NumPolizaSeguro:PChar; TipoEmbarcacion:PChar; Matricula:PChar; NumeroOMI:PChar; AnioEmbarcacion:PChar; NombreEmbarc:PChar; NacionalidadEmbarc:PChar; UnidadesDeArqBruto:PChar; TipoCarga:PChar; NumCertITC:PChar; Eslora:PChar; Manga:PChar; Calado:PChar; LineaNaviera:PChar; NombreAgenteNaviero:PChar; NumAutorizacionNaviero:PChar; NumViaje:PChar; NumConocEmbarc:PChar; MatriculaContenedor:PChar; TipoContenedor:PChar; NumPrecinto:PChar);cdecl;
 VirtualXML_CartaPorte20AddMercanciasTransporteMaritimoContenedor: procedure	       ( p:LongInt; MatriculaContenedor:PChar; TipoContenedor:PChar; NumPrecinto:PChar); cdecl;
 VirtualXML_CartaPorte20SetMercanciasTransporteAereo: procedure			                 ( p:LongInt; PermSCT:PChar; NumPermisoSCT:PChar; MatriculaAeronave:PChar; NombreAseg:PChar; NumPolizaSeguro:PChar; NumeroGuia:PChar; LugarContrato:PChar; CodigoTransportista:PChar; RFCEmbarcador:PChar; NumRegIdTribEmbarc:PChar; ResidenciaFiscalEmbarc:PChar; NombreEmbarcador:PChar); cdecl;
 VirtualXML_CartaPorte20SetMercanciasTransporteFerroviario: procedure		             ( p:LongInt; TipoDeServicio:PChar; TipoDeTrafico:PChar; NombreAseg:PChar; NumPolizaSeguro:PChar; TipoDerechoDePaso:PChar; KilometrajePagado:PChar; TipoCarro:PChar; MatriculaCarro:PChar; GuiaCarro:PChar; ToneladasNetasCarro:PChar; TipoContenedor:PChar; PesoContenedorVacio:PChar; PesoNetoMercancia:PChar); cdecl;
 VirtualXML_CartaPorte20AddMercanciasTransporteFerroviarioDerechosDePaso: procedure  ( p:LongInt; TipoDerechoDePaso:PChar; KilometrajePagado:PChar);cdecl;
 VirtualXML_CartaPorte20AddMercanciasTransporteFerroviarioCarro: procedure	         ( p:LongInt; TipoCarro:PChar; MatriculaCarro:PChar; GuiaCarro:PChar; ToneladasNetasCarro:PChar; TipoContenedor:PChar; PesoContenedorVacio:PChar; PesoNetoMercancia:PChar); cdecl;
 VirtualXML_CartaPorte20AddMercanciasTransporteFerroviarioCarroContenedor: procedure ( p:LongInt; TipoContenedor:PChar; PesoContenedorVacio:PChar; PesoNetoMercancia:PChar); cdecl;
 VirtualXML_CartaPorte20AddFiguraTransporteTiposFigura: procedure		                 ( p:LongInt; TipoFigura:PChar; RFCFigura:PChar; NumLicencia:PChar; NombreFigura:PChar; NumRegIdTribFigura:PChar; ResidenciaFiscalFigura:PChar; ParteTransporte:PChar; Calle:PChar; NumeroExterior:PChar; NumeroInterior:PChar; Colonia:PChar; Localidad:PChar; Referencia:PChar; Municipio:PChar; Estado:PChar; Pais:PChar; CodigoPostal:PChar);cdecl;
 VirtualXML_CartaPorte20AddFiguraTransporteTiposFiguraPartesTransporte:procedure	   ( p:LongInt; ParteTransporte:PChar); cdecl;
 VirtualXML_SetLeyendasFiscales10Full: procedure                                     ( p:LongInt; Dis01:PChar; Norma01:PChar; Texto01:PChar; Dis02:PChar; Norma02:PChar; Texto02:PChar; Dis03:PChar; Norma03:PChar; Texto03:PChar; Dis04:PChar; Norma04:PChar; Texto04:PChar; Dis05:PChar; Norma05:PChar; Texto05:PChar; Dis06:PChar; Norma06:PChar; Texto06:PChar; Dis07                   :PChar;  Norma07             :PChar;  Texto07       :PChar;  Dis08              :PChar;  Norma08       :PChar;  Texto08    :PChar;   Dis09    :PChar; Norma09:PChar;  Texto09:PChar;  Dis10:PChar;  Norma10:PChar;  Texto10:PChar ); cdecl
 VirtualXML_CancelaCFDI2022 : function 		      				                             ( szUsuario:PChar; szRfcEmisor:PChar; szMotivo:PChar; szUuid:PChar; szFolioSust:PChar; szCert:PChar; szKey:PChar; szPwd:PChar; szServer:PChar; szResult:PChar; szLog:PChar ) : LongInt; cdecl;
 VirtualXML_CancelaCFDI2022Ssl : function                              					     ( szUsuario:PChar; szRfcEmisor:PChar; szMotivo:PChar; szUuid:PChar; szFolioSust:PChar; szCert:PChar; szKey:PChar; szPwd:PChar; szServer:PChar; szResult:PChar; szLog:PChar ) : LongInt; cdecl;
 VirtualXML_Pagos20AddPago : procedure 						                                   ( p:LongInt; FechaPago:PChar; FormaDePagoP:PChar; MonedaP:PChar; TipoCambioP:PChar; Monto:PChar; NumOperacion:PChar; RfcEmisorCtaOrd:PChar; NomBancoOrdExt:PChar; CtaOrdenante:PChar; RfcEmisorCtaBen:PChar; CtaBeneficiario:PChar; TipoCadPago:PChar; CertPago:PChar; CadPago:PChar; SelloPago:PChar );cdecl;
 VirtualXML_Pagos20AddPagoDoctoRelacionado : procedure 				                       ( p:LongInt; idDocumento:PChar; Serie:PChar; Folio:PChar; MonedadDR:PChar; EquivalenciaDR:PChar; NumParcialidad:PChar; ImpSaldoAnt:PChar; ImpPagado:PChar; ImpSaldoInsoluto:PChar; ObjetoImpDR:PChar );cdecl;
 VirtualXML_Pagos20AddPagoDoctoRelacionadoRetencionDR : procedure 		               ( p:LongInt; BaseDR:PChar; ImpuestoDR:PChar; TipoFactorDR:PChar; TasaOCuotaDR:PChar; ImporteDR:PChar );cdecl;
 VirtualXML_Pagos20AddPagoDoctoRelacionadoTrasladoDR : procedure 		                 ( p:LongInt; BaseDR:PChar; ImpuestoDR:PChar; TipoFactorDR:PChar; TasaOCuotaDR:PChar; ImporteDR:PChar );cdecl;
 VirtualXML_Pagos20AddPagoImpuestosPRetencionP : procedure 			                     ( p:LongInt; ImpuestoP:PChar; ImporteP:PChar );cdecl;
 VirtualXML_Pagos20AddPagoImpuestosPTrasladoP : procedure 			                     ( p:LongInt; BaseP:PChar; ImpuestoP:PChar; TipoFactorP:PChar; TasaOCuotaP:PChar; ImporteP:PChar );cdecl;
 VirtualXML_SetPagos20 : procedure 						                                       ( p:LongInt; TotalRetencionesIVA:PChar; TotalRetencionesISR:PChar; TotalRetencionesIEPS:PChar; TotalTrasladosBaseIVA16:PChar; TotalTrasladosImpuestoIVA16:PChar; TotalTrasladosBaseIVA8:PChar; TotalTrasladosImpuestoIVA8:PChar; TotalTrasladosBaseIVA0:PChar; TotalTrasladosImpuestoIVA0:PChar; TotalTrasladosBaseIVAExento:PChar; MontoTotalPagos:PChar);cdecl;
 VirtualXML_AddCfdiRelacionado_cfdi40 : procedure 				                           ( p:LongInt; UUID:PChar ); cdecl;
 VirtualXML_AddCfdiRelacionados_cfdi40 : procedure 				                           ( p:LongInt; TipoRelacion:PChar; UUID1:PChar; UUID2:PChar; UUID3:PChar; UUID4:PChar; UUID5:PChar; UUID6:PChar; UUID7:PChar; UUID8:PChar; UUID9:PChar; UUID10:PChar); cdecl;
 VirtualXML_AddComplemento_cfdi40 : procedure 					                             ( p:LongInt; complementoXml:PChar ); cdecl;
 VirtualXML_AddComplementoConcepto_cfdi40 : procedure 				                       ( p:LongInt; complementoXml:PChar ); cdecl;
 VirtualXML_AddConcepto_cfdi40 : procedure 					                                 ( p:LongInt; ClaveProdServ:PChar; NoIdentificacion:PChar; Cantidad:PChar; ClaveUnidad:PChar; Unidad:PChar; Descripcion:PChar; ValorUnitario:PChar; Importe:PChar; Descuento:PChar; ObjetoImp:PChar ); cdecl;
 VirtualXML_AddConceptoCuentaPredial_cfdi40 : procedure 				                     ( p:LongInt; Numero:PChar ); cdecl;
 VirtualXML_AddConceptoInformacionAduanera_cfdi40 : procedure 			                 ( p:LongInt; NumperoPedimento:PChar ); cdecl;
 VirtualXML_AddConceptoParte_cfdi40 : procedure 					                           ( p:LongInt; ClaveProdServ:PChar; NoIdentificacion:PChar; Cantidad:PChar; Unidad:PChar; Descripcion:PChar; ValorUnitario:PChar; Importe:PChar; NumperoPedimento1:PChar; NumperoPedimento2:PChar; NumperoPedimento3:PChar; NumperoPedimento4:PChar; NumperoPedimento5:PChar ); cdecl;
 VirtualXML_AddConceptoRetencion_cfdi40 : procedure 				                         ( p:LongInt; Base:PChar; Impuesto:PChar; Tipofactor:PChar; TasaOCuota:PChar; Importe:PChar ); cdecl;
 VirtualXML_AddConceptoTraslado_cfdi40 : procedure 				                           ( p:LongInt; Base:PChar; Impuesto:PChar; Tipofactor:PChar; TasaOCuota:PChar; Importe:PChar ); cdecl;
 VirtualXML_AddRetencion_cfdi40 : procedure 	                            				   ( p:LongInt; Impuesto:PChar; Importe:PChar ); cdecl;
 VirtualXML_AddTraslado_cfdi40 : procedure 					                                 ( p:LongInt; Impuesto:PChar; TipoFactor:PChar; TasaOCuota:PChar; Importe:PChar; Base:PChar ); cdecl;
 VirtualXML_SetAddenda_cfdi40 : procedure 					                                 ( p:LongInt; text:PChar ); cdecl;
 VirtualXML_SetAddendaText_cfdi40 : procedure 					                             ( p LongInt; text:PChar ); cdecl;
 VirtualXML_SetCompleteXML_cfdi40 : procedure 					                             ( p:LongInt; TextoXMLoArchivoXML:PChar); cdecl;
 VirtualXML_SetComprobanteInfo_cfdi40 : procedure 				                           ( p:LongInt; Serie:PChar; Folio:PChar; Fecha:PChar; FormaDePago:PChar; CondicionesDePago:PChar; SubTotal:PChar; Descuento:PChar; Moneda:PChar; TipoCambio:PChar; Total:PChar; TipoDeComprobante:PChar; MetodoDePago:PChar; LugarExpedicion:PChar; Confirmacion:PChar; Exportacion:PChar ); cdecl;
 VirtualXML_SetConceptoACuentaTerceros_cfdi40 : procedure 		   	                   ( p:LongInt; RfcACuentaTerceros:PChar; NombreACuentaTerceros:PChar; RegimenFiscalACuentaTerceros:PChar; DomicilioFiscalACuentaTerceros:PChar ); cdecl;
 VirtualXML_SetEmisorInfo_cfdi40 : procedure 					                               ( p:LongInt; RFC:PChar; Nombre:PChar; RegimenFiscal:PChar; FacAtrAdquirente:PChar ); cdecl;
 VirtualXML_SetInformacionGlobal_cfdi40 : procedure 				                         ( p:LongInt; Periodicidad:PChar; Meses:PChar; Ao:PChar ); cdecl;
 VirtualXML_SetImpuestosInfo_cfdi40 : procedure 					                           ( p:LongInt; totalImpuestosTrasladados:PChar; totalImpuestosRetenidos:PChar ); cdecl;
 VirtualXML_SetReceptorInfo_cfdi40 : procedure 					                             ( p:LongInt; RFC:PChar; Nombre:PChar; ResidenciaFiscal:PChar; NumRegIdTrib:PChar; UsoCFDI:PChar; DomicilioFiscalReceptor:PChar; RegimenFiscalReceptor:PChar ); cdecl;
 Utils_SendEmail : function 		      			 	    	                                 ( SmtpServer:PChar; int:LongInt; SmtpUserName:PChar; SmtpPassword:PChar; MessageTo:PChar; MessageFrom:PChar; MessageSubjet:PChar; MessageBody:PChar; MessageAttach1:PChar; MessageAttach2:PChar; MessageAttach3:PChar; OutLog:PChar; Reserved:PChar ) : LongInt; cdecl
 VirtualXML_ApiEmisorAdd : function 						                                     ( apikey:PChar; usuario:PChar; rfcemisor:PChar; pwdconsulta:PChar; razonsocial:PChar; email:PChar; contacto:PChar; asignacion:LongInt; suspendido:LongInt; notificacion:LongInt; outLog:PChar; reserved:PChar ) : LongInt; cdecl;
 VirtualXML_ApiEmisorUpd : function 						                                     ( apikey:PChar; usuario:PChar; rfcemisor:PChar; pwdconsulta:PChar; razonsocial:PChar; email:PChar; contacto:PChar; suspendido:LongInt; notificacion:LongInt; outLog:PChar;  reserved:PChar ): LongInt; cdecl;
 VirtualXML_ApiEmisorAsigna : function 						                                   ( apikey:PChar; usuario:PChar; rfcemisor:PChar; asignacion:LongInt; threshold:LongInt; limit:LongInt; active:LongInt; outLog:PChar; reserved:PChar ): LongInt; cdecl;
 VirtualXML_ApiUsuarioAdd : function 						                                     ( apikey:PChar; usuario:PChar; distribuidor:PChar; pwd:PChar; razonsocial:PChar; email:PChar; contacto:PChar; rfc:PChar; asignacion:LongInt; outLog:PChar; xtra:PChar; reserved:PChar ): LongInt; cdecl;
 VirtualXML_ApiUsuarioUpd : function 						                                     ( apikey:PChar; usuario:PChar; distribuidor:PChar; pwd:PChar; razonsocial:PChar; email:PChar; contacto:PChar; rfc:PChar; outLog:PChar; xtra:PChar; reserved:PChar ): LongInt; cdecl;
 Retenciones_NewWithLog : function         					                                 ( szVersion:PChar;  logfile:PChar ): LongInt; cdecl;
 Retenciones_SetVirtualPACInfo : procedure 					                                 ( p:LongInt; szUser:PChar; servidor:PChar ); cdecl;
 Retenciones_ProcesaDocumento : function  					                                 ( p:LongInt; csd:PChar; key:PChar; keypwd:PChar; outfile:PChar ): LongInt; cdecl;
 Retenciones_Free : procedure   							                                       ( p:LongInt ); cdecl;
 Retenciones_SetAddendaText : procedure 						                                 ( p:LongInt; text:PChar ); cdecl;
 Retenciones_SetAddendaXML : procedure 						                                   ( p:LongInt; xmlAddenda:PChar ); cdecl;
 Retenciones_SetRetencionesCfdiRetenRelacionados: procedure 			                   ( p:LongInt; TipoRelacion:PChar; UUID:PChar ); cdecl;
 Retenciones_SetRetencionesEmisor : procedure 					                             ( p:LongInt; RfcE:PChar;  NomDenRazSocE:PChar; RegimenFiscalE:PChar ); cdecl;
 Retenciones_SetRetencionesInfo : procedure 					                               ( p:LongInt; FolioInt:PChar; FechaExp:PChar; LugarExpRetenc:PChar; CveRetenc:PChar; DescRetenc:PChar ); cdecl;
 Retenciones_SetRetencionesPeriodo : procedure          				                     ( p:LongInt; MesIni:PChar; MesFin:PChar; Ejercicio:PChar ); cdecl;
 Retenciones_SetRetencionesReceptor : procedure 					                           ( p:LongInt; NacionalidadR:PChar; RfcR:PChar; NomDenRazSocRNacional:PChar; CurpR:PChar; DomicilioFiscalR:PChar; NumRegIdTribR:PChar; NomDenRazSocRExtranjero:PChar ); cdecl;
 Retenciones_SetRetencionesTotales : procedure 					                             ( p:LongInt; MontoTotOperacion:PChar; MontoTotGrav:PChar; MontoTotExent:PChar; MontoTotRet:PChar; UtilidadBimestral:PChar; ISRCorrespondiente:PChar ); cdecl;
 Retenciones_AddRetencionesTotalesImpRetenidos : procedure 			                     ( p:LongInt; BaseRet:PChar; ImpuestoRet:PChar; MontoRet:PChar; TipoPagoRet:PChar ); cdecl;
 Retenciones_SetComplementoArrendamientoenfideicomiso10 : procedure 		             ( p:LongInt; PagProvEfecPorFiduc:PChar; RendimFideicom:PChar; DeduccCorresp:PChar; MontTotRet:PChar; MontResFiscDistFibras:PChar; OtrosConceptDistr:PChar; DescrMontOtrosConceptDistr:PChar ); cdecl;
 Retenciones_SetComplementoDividendos10 : procedure 				                         ( p:LongInt; CveTipDivOUtil:PChar; MontISRAcredRetMexico:PChar; MontISRAcredRetExtranjero:PChar; MontRetExtDivExt:PChar; TipoSocDistrDiv:PChar; ISRAcredNal:PChar; MontDivAcumNal:PChar; MontDivAcumExt:PChar; ProporcionRem:PChar ); cdecl;
 Retenciones_SetComplementoEnajenaciondeAcciones10 : procedure 			                 ( p:LongInt; ContratoIntermediacion:PChar; Ganancia:PChar; Perdida:PChar ); cdecl;
 Retenciones_SetComplementoFideicomisonoempresarial10 : procedure    		             ( p:LongInt; MontTotEntradasPeriodo:PChar; PartPropAcumDelFideicom:PChar; PropDelMontTotEntradas:PChar; Concepto:PChar; MontTotEgresPeriodo:PChar; PartPropDelFideicom:PChar; PropDelMontTotSalidas:PChar; ConceptoS:PChar; MontRetRelPagFideic:PChar; DescRetRelPagFideic:PChar ); cdecl;
 Retenciones_SetComplementoIntereses10 : procedure 				                           ( p:LongInt; SistFinanciero:PChar; RetiroAORESRetInt:PChar;  OperFinancDerivad:PChar; MontIntNominal:PChar; MontIntReal:PChar; Perdida:PChar ); cdecl;
 Retenciones_SetComplementoIntereseshipotecarios10 : procedure 			                 ( p:LongInt; CreditoDeInstFinanc:PChar; SaldoInsoluto:PChar; PropDeducDelCredit:PChar; MontTotIntNominalesDev:PChar; MontTotIntNominalesDevYPag:PChar; MontTotIntRealPagDeduc:PChar; NumContrato:PChar ); cdecl;
 Retenciones_SetComplementoOperacionesconderivados10 : procedure 		                 ( p:LongInt; MontGanAcum:PChar; MontPerdDed:PChar ); cdecl;
 Retenciones_SetComplementoPagosaextranjeros10 : procedure 			                     ( p:LongInt; EsBenefEfectDelCobro:PChar; PaisDeResidParaEfecFisc:PChar; ConceptoPagoNoBeneficiario:PChar; DescripcionConceptoNoBeneficiario:PChar;  RFC:PChar;  CURP:PChar; NomDenRazSocB:PChar; ConceptoPagoBeneficiario:PChar; DescripcionConceptoBeneficiario:PChar ); cdecl;
 Retenciones_SetComplementoPlanesderetiro11 : procedure 				                     ( p:LongInt; SistemaFinanc:PChar; MontTotAportAnioInmAnterior:PChar; MontIntRealesDevengAniooInmAnt:PChar; HuboRetirosAnioInmAntPer:PChar; MontTotRetiradoAnioInmAntPer:PChar; MontTotExentRetiradoAnioInmAnt:PChar; MontTotExedenteAnioInmAnt:PChar; HuboRetirosAnioInmAnt:PChar; MontTotRetiradoAnioInmAnt:PChar; NumReferencia:PChar; TipoAportacionODeposito1:PChar; MontAportODep1:PChar; RFCFiduciaria1:PChar; TipoAportacionODeposito2:PChar; MontAportODep2:PChar; RFCFiduciaria2:PChar; TipoAportacionODeposito3:PChar; MontAportODep3:PChar; RFCFiduciaria3:PChar ); cdecl;
 Retenciones_SetComplementoPlataformasTecnologicas10 : procedure 		                 ( p:LongInt; Periodicidad:PChar; NumServ:PChar; MonTotServSIVA:PChar; TotalIVATrasladado:PChar;  TotalIVARetenido:PChar;  TotalISRRetenido:PChar; DifIVAEntregadoPrestServ:PChar; MonTotalporUsoPlataforma:PChar; MonTotalContribucionGuber:PChar ); cdecl;
 Retenciones_AddComplementoPlataformasTecnologicas10DetallesDelServicio : procedure  ( p:LongInt; FormaPagoServ:PChar; TipoDeServ:PChar; SubTipServ:PChar; RFCTerceroAutorizado:PChar; FechaServ:PChar; PrecioServSinIVA:PChar; BaseTrasladados:PChar; ImpuestoTrasladados:PChar; TipoFactorTrasladados:PChar; TasaCuotaTrasladados:PChar; ImporteTrasladados:PChar; ImpContrib:PChar; EntidadDondePagaLaContribucion:PChar; BaseComision:PChar; PorcentajeComision:PChar; ImporteComision:PChar ); cdecl;
 Retenciones_SetComplementoPremios10 : procedure 				                             ( p:LongInt; EntidadFederativa:PChar; MontTotPago:PChar; MontTotPagoGrav:PChar; MontTotPagoExent:PChar ); cdecl;
 Retenciones_SetComplementoSectorFinanciero10 : procedure 			                     ( p:LongInt; IdFideicom:PChar; NomFideicom:PChar; DescripFideicom:PChar ); cdecl;
 VirtualXML_MicroValidaDatosFiscales : function     				                         ( apikey:PChar; usuario:PChar; rfcemisor:PChar; rfcreceptor:PChar; nombre:PChar; regimenfiscal:PChar; CodigoPostal:PChar; csdcer:PChar; csdkey:PChar; pwdkey:PChar; ResultFile:PChar; OutLog:PChar; Reserved:PChar ): LongInt; cdecl;
 VirtualXML_MicroConsultaDatosFiscales : function 	  			                         ( apikey:PChar; usuario:PChar; rfcemisor:PChar; rfcreceptor:PChar; csdcer:PChar; csdkey:PChar; pwdkey:PChar; ResultFile:PChar; OutLog:PChar; Reserved:PChar ); LongInt; cdecl;
}
